Lua_AllEntranceWindow = class("Lua_AllEntranceWindow", Lua_Window)
function Lua_AllEntranceWindow:ctor()
    self:superCall("ctor");

    self.w = 703;
    self.h = 900;
    self.showBlurMask = true;
    self.layer = MainWinDefine.MAX_TOP_LAYER;
    self.windowName = "Lua_AllEntranceWindow";
    self.showWinBg = true;
    self.winBgAtlas = "common_altas_1";
    self.winBgSprite = "xui_common_window_003";
    self.showCloseText = true;
    self.isClickClose = true;
    self.closeTextPosY = -(self.h / 2 + 50);
end

function Lua_AllEntranceWindow:buildShowItem()
	self:superCall("buildShowItem");

    self.list = Array();
    self.list:add({ label = "GC", owner = self, fun = self.onGcClick });
    self.list:add({ label = "GM", winName = "Lua_TestGMWindow" });
    -- self.list:add({ label = "测试", winName = "Lua_TestScrollViewWindow" });
    self.list:add({ label = "消息解析", winName = "Lua_MsgDecodeWindow" });
    self.list:add({ label = "模拟发包", winName = "Lua_MsgSimulateSendWindow" });
    self.list:add({ label = "ID查找", winName = "Lua_IdsListShowWindow" });
    self.list:add({ label = "邮件", winName = "Lua_MailWindow", param = 1 });
    self.list:add({ label = "招募", winName = "Lua_RecruitMainWindow", param = 1 });
    self.list:add({ label = "生命神树", winName = "Lua_LifeTreeWindow" });
    self.list:add({ label = "充值", winName = "Lua_RaccoonMartWindow", param = {main_id = 9, sub_id = 8} });
    self.list:add({ label = "集市", winName = "Lua_ShopWindow", param = { main_id = 1001 } });
    self.list:add({ label = "聊天", winName = "Lua_ChatWindow", param = 1 });
    self.list:add({ label = "灵能机", winName = "Lua_HeroAssemblyWindow", param = { main_id = 2 }});
    self.list:add({ label = "主角", winName = "Lua_RoleWindow" });
    self.list:add({ label = "好友", winName = "Lua_FriendBaseWindow" });
    self.list:add({ label = "精灵商店", winName = "Lua_SpiritShopWindow", param = 1 });
    self.list:add({ label = "爬塔", winName = "Lua_ClimbTowerEntranceWindow" });
    self.list:add({ label = "斗技场", winName = "Lua_ArenaWindow" });
	self.list:add({ label = "试炼副本", winName = "Lua_TrialWindow", param = 1 });
    self.list:add({ label = "转盘", winName = "Lua_LuckyTurntableWindow" });	
    self.list:add({ label = "下载奖励", winName = "Lua_DownLoadRewardWindow" });
    self.list:add({ label = "在线奖励", winName = "Lua_OnLineRewardWindow" });
    self.list:add({ label = "无穷战殿", owner = self, fun = self.onInfinityHall });
    self.list:add({ label = "首充", winName = "Lua_FirstRechargeWindow" });
    self.list:add({ label = "每日首充", winName = "Lua_DailyRechargeWindow" });
    self.list:add({ label = "冠军赛", winName = "Lua_ChampionshipWindow" });
    self.list:add({ label = "联盟", winName = "Lua_AllianceMainWindow" });
	self.list:add({ label = "混沌森林", winName = "Lua_ChaosForestWindow" });
    self.list:add({ label = "十连自选", winName = "Lua_TenRecruitSelectWindow" });
    self.list:add({ label = "八天登录", winName = "Lua_SevenDaySignInWindow" });
    self.list:add({ label = "星魂试炼", owner = self, fun = self.openStarTrialWindow });
    self.list:add({ label = "浣熊集市", winName = "Lua_RaccoonMartWindow", param = {main_id = 4} });
    self.list:add({ label = "跨服时空", winName = "Lua_CrossServerWindow" });
    self.list:add({ label = "加载页", winName = "Lua_LoadingScreenWindow" });
    self.list:add({ label = "日常任务", winName = "Lua_TaskBaseWindow", param = 1 });
    self.list:add({ label = "精彩活动", winName = "Lua_ExcellentActivityWindow", param = 1006 });
    self.list:add({ label = "红点测试", winName = "Lua_TestRedPointWindow" });
    self.list:add({ label = "巅峰对决", owner = self, fun = self.openPeakDuel });
    self.list:add({ label = "神器解锁", winName = "Lua_ExploreTourUnlockWindow", param = 201 });
    self.list:add({ label = "藏宝柜", winName = "Lua_CollectionWindow" });
    self.list:add({ label = "寂灭岛", winName = "Lua_EquipCopyWindow", param = {index = 1} });
    if DataCenter ~= nil and DataCenter.vipData ~= nil then
        self.list:add({ label = "VIP名望提升", winName = "Lua_VipUpTipsWindow", param = DataCenter.vipData.level });
    end
    self.list:add({ label = "百抽盛典", owner = self, fun = self.onOpenHundredCeremony });
    self.list:add({ label = "打开创角", owner = self, fun = self.onCreateRole });
    self.list:add({ label = "3D主城", owner = self, fun = self.onOpen3DZhucheng });
    self.list:add({ label = "六边形地图", winName = "Lua_HexagonMapWindow" });
    self.list:add({ label = "重连界面", winName = "Lua_ReconnectWindow" });
    self.list:add({ label = "古镇秘藏", winName = "Lua_TownTreasureWindow" });
    self.list:add({ label = "英雄降临", winName = "Lua_OpenServerHeroComeWindow" });
    self.list:add({ label = "七日目标", winName = "Lua_OpenServerCarnivalWindow" });
    self.list:add({ label = "神域试炼", winName = "Lua_DivineDomainTrialEntranceWindow" });
    self.list:add({ label = "百发百中", winName = "Lua_CrackShotGetPosWindow" });
    self.list:add({ label = "主线地图", winName = "Lua_MainLineMapWindow" });

    self.btnArr = Array();
    for i = 1, self.list:getSize() do
        local posX = ((i - 1) % 4) * 165 - 245;
        local posY = 390 + Mathf.Floor((i - 1) / 4) * 60 * -1;
        local btn = UICreate.createButton(self.content, self.list[i].label, posX, posY, 141, 54);
        btn.name = tostring(i);
        btn.siblingIndex = i;
        btn:setStyle(14)
        btn.txt:setLocation(0, 0, 0)
        btn.txt.fontSize = 24
        if self.list[i].owner ~= nil and self.list[i].fun ~= nil then
            btn:addClickFuntion(self.list[i].owner, self.list[i].fun);
        else
            btn:addClickFuntion(self, self.onOpenWindow);
        end
        self.btnArr:add(btn);
    end
end

function Lua_AllEntranceWindow:dispose()
    if self.list ~= nil then
        while self.list:getSize() > 0 do
            local obj = self.list:remove(1);
            obj.label = nil;
            obj.owner = nil;
            obj.fun = nil;
        end
        self.list:clear();
        self.list = nil;
    end
    if self.btnArr ~= nil then
        self.btnArr:dispose();
        self.btnArr:clear();
        self.btnArr = nil;
    end
	self:superCall("dispose");
end

function Lua_AllEntranceWindow:onGcClick(go)
    CommonUtil.clearMemory();
end

function Lua_AllEntranceWindow:onOpenWindow(go)
    local index = tonumber(go.name);
    local item = self.list[index];
    Lua_WindowUtil.openWin(item.winName, Lua_WinParam.ACTION_OPEN, item.param);
    self:hide();
end

function Lua_AllEntranceWindow:onInfinityHall(go)
    if not DataCenter.infinityHallData.bInfinityHallOpened then
        Lua_WindowUtil.openWin("Lua_InfinityHallTurnonWindow", Lua_WinParam.ACTION_OPEN);
    else
        Lua_WindowUtil.openWin("Lua_InfinityHallWindow", Lua_WinParam.ACTION_OPEN);
    end
    self:hide();
end

function Lua_AllEntranceWindow:openStarTrialWindow(go)
    local recordId = DataCenter.fightData:getRecordIdByTemplateId(Lua_FightDefine.TEMPLATE_ID_STARTRIAL);
    if recordId > 0 then
        DataCenter.fightData:showFightToStageByRid(recordId);
    else
        Lua_WindowUtil.openWin("Lua_StarTrialWindow", Lua_WinParam.ACTION_OPEN);
    end
    self:hide();
end

function Lua_AllEntranceWindow:openPeakDuel(go)
    if DataCenter.funcPathUtil:gotoFunction(1025) then
        self:hide();
    end
end

function Lua_AllEntranceWindow:onOpenHundredCeremony(go)
    DataCenter.funcPathUtil:gotoFunction(1094, true);
end

function Lua_AllEntranceWindow:onCreateRole(go)
    if not DataCenter.loginData.isCreateRole then
        Lua_WindowUtil.openWin("Lua_CreateRoleWindow", Lua_WinParam.ACTION_OPEN);
    end
end