checkRequire("Lua_DebugOutPutData");
Lua_DebugOutputPanel = class("DebugOutputPanel", Lua_DisplayObject);
function Lua_DebugOutputPanel:ctor(p)
	self.showMsg = 0;
	self.index = 0;
	if Lua_DebugOutputPanel.outData == nil then
		Lua_DebugOutputPanel.outData = Lua_DebugOutPutData.new();
	end
	self:superCall("ctor", p, "DebugOutputPanel_skin");
end

function Lua_DebugOutputPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.textArea = Lua_TextArea.new(self.content, 400, 150);
	self.textArea:setLocation(0, 50, 0);

	self.cbStart.selected = Lua_DebugOutputPanel.outData:isStart();
	self.cbStart:addBoxChange(self, self.onStartBoxClick);
	self.btnCopy:addClickFuntion(self,self.onBtnCopyClick);
	self.btnClear:addClickFuntion(self, self.onBtnClearClick);
	self.btnFilter:addClickFuntion(self, self.onBtnFilterClick);

	self:addLuaEvent("NEW_MSG_TRACE", self, self.updateTextArea);
	self:updateTextArea();
end

function Lua_DebugOutputPanel:updateTextArea()
	self.str = "";
	local msgList = Lua_DebugOutputPanel.outData.msgList;
	if msgList == nil then
		self.textArea:setText(self.str);
		return;
	end

	for i = 1, msgList:getSize() do
		if self.showMsg == 0 or self.showMsg == msgList[i].id then
			self.str = self.str..msgList[i].id.."  err:"..msgList[i].err.."  index:"..self.index.."\nmsg:"..msgList[i].data.."\n";
		end
	end
	self.textArea:setText("<color=#4A6793>"..self.str.."</color>");
end

function Lua_DebugOutputPanel:onStartBoxClick(state)
	if Lua_DebugOutputPanel.outData:isStart() == false then
		Lua_DebugOutputPanel.outData:startListen();
	else
		Lua_DebugOutputPanel.outData:endListen();
	end
end

function Lua_DebugOutputPanel:onBtnCopyClick(go)
	LanUtil.copyToClipboard(self.str);
end

function Lua_DebugOutputPanel:onBtnClearClick(go)
	Lua_DebugOutputPanel.outData:clearStr();
	self:updateTextArea();
end

function Lua_DebugOutputPanel:onBtnFilterClick(go)
	self.showMsg = tonumber(self.inputText.text);
	self:updateTextArea();
end