checkRequire("Lua_DebugOutputPanel");
Lua_DebugWindow = class("Lua_DebugWindow", Lua_Window)
function Lua_DebugWindow:ctor()
	self:superCall("ctor");

	self.w = 0;
	self.h = 0;
	self.layer = MainWinDefine.MAX_TOP_LAYER;
	self.windowName = "Lua_DebugWindow";
	self.skinName = "DebugWindow_skin";
end

function Lua_DebugWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.inputText:ActivateInputField();

	-- self.showTestEffPlayIdx = 0;
	-- self.showTestEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_danchou_crumb", "ui_danchou_crumb", 0, -350);
	-- self.showTestEff:addLuaSpineAniEvtFun(self, self.onSpineEffAni);
	-- self.showTestEff:setSpineAniState(0, "loop_1");

	self.winBg.clickScale = false;
	self.winBg:addMousDownFuntion(self, self.onMouseDownHandle);
	self.winBg:addMouseUpFuntion(self, self.onMouseUpHandle);

	self.btnSend:addClickFuntion(self, self.onBtnSendClick);
	self.cbMove:addBoxChange(self, self.onMoveBoxClick);
	self.cbMap:addBoxChange(self, self.onMapBoxClick);

	self.list = Array();
	self.list:add({ label = "GC", owner = self, fun = self.onGcClick });
	self.list:add({ label = "GM", owner = self, fun = self.onOpenGM });
	self.list:add({ label = "摄像机参数", owner = self, fun = self.onCameraInfoClick });
	self.list:add({ label = "相机观察点", owner = self, fun = self.onCameraLookAtClick });
	self.list:add({ label = "获取位置", owner = self, fun = self.onGetMapPosClick });
	self.list:add({ label = "包信息", owner = self, fun = self.onPackageInfo });
	self.list:add({ label = "消息号打印", owner = self, fun = self.onMsgOutClick });
	self.list:add({ label = "颜色转换", owner = self, fun = self.onColorChange });
	if GlobalVar.bWriteMsg then
		self.list:add({ label = "取保消息", owner = self, fun = self.onSaveMsgTxt });
		self.msgSaveBtnIdx = self.list:getSize();
	else
		self.list:add({ label = "保存消息", owner = self, fun = self.onSaveMsgTxt });
		self.msgSaveBtnIdx = self.list:getSize();
	end
	if DataCenter.bCameraDragRange then
		self.list:add({ label = "镜头还原", owner = self, fun = self.onCameraDrag });
		self.camDragBtnIdx = self.list:getSize();
	else
		self.list:add({ label = "镜头解除", owner = self, fun = self.onCameraDrag });
		self.camDragBtnIdx = self.list:getSize();
	end
	self.list:add({ label = "场景切换", owner = self, fun = self.onSceneChange });
	self.list:add({ label = "战斗测试", owner = self, fun = self.onPlayFightRecords });
	self.list:add({ label = "开发调试", owner = self, fun = self.onDevelopDebugTest });
	self.list:add({ label = "渲染质量", owner = self, fun = self.onSetQualityLv });
	self.list:add({ label = "界面隐藏", owner = self, fun = self.onHideUICamera });
	self.list:add({ label = "调试窗口", owner = self, fun = self.onOpenTestWin });
	self.list:add({ label = "错误窗口", owner = self, fun = self.onShowError });
	self.list:add({ label = "FPS", owner = self, fun = self.onShowFPS }); 
	self.list:add({ label = "渲染状态", owner = self, fun = self.onShowRenderStats });
	if Lua_PlatformUtil.IsAndroid() then
		self.list:add({ label = "电量状态", owner = self, fun = self.onShowPowerStats });
	end
	-- self.list:add({ label = "扭曲特效", owner = self, fun = self.onAddNiuQuEff });
	self.list:add({ label = "人生赢家", owner = self, fun = self.onOutputMemoryAsset });
	self.list:add({ label = "主线调试", owner = self, fun = self.onMainlineDebug });
	if Lua_PlatformUtil.IsWindowsEditor() then
		self.list:add({ label = "刷新Lua", owner = self, fun = self.updateLuaFile });
		self.list:add({ label = "测试后台活动", owner = self, fun = self.onBackstageActivityTest});
	end
	if Lua_PlatformUtil.IsWindowsEditor() or Lua_PlatformUtil.IsWindowsPlayer() then
		self.list:add({ label = "分辨率", owner = self, fun = self.onScreenResolution });
		self.list:add({ label = "视口转换", owner = self, fun = self.onScreenAdapter });
	end
	self.list:add({ label = "开启全部功能", owner = self, fun = self.onFuncOpen });
	self.list:add({ label = "两点距离", owner = self, fun = self.onVecDis });
	self.list:add({ label = "资源列表", owner = self, fun = self.onOutputResInfo });
	self.list:add({ label = "音效播放", owner = self, fun = self.onPlaySound });
	self.list:add({ label = "主线前景", owner = self, fun = self.onMainlinePreView });
	self.list:add({ label = "引导测试", owner = self, fun = self.onGuideTestClick });
	if DataCenter.guideData.bOpenGuide then
		self.list:add({ label = "关闭引导", owner = self, fun = self.onGuideCloseClick });
		self.guideCloseBtnIdx = self.list:getSize();
	else
		self.list:add({ label = "开启引导", owner = self, fun = self.onGuideCloseClick });
		self.guideCloseBtnIdx = self.list:getSize();
	end
	self.list:add({ label = "动态表情", owner = self, fun = self.onEmjioClick });
	self.list:add({ label = "红点树", owner = self, fun = self.onRedPointTreeClick });
	self.list:add({ label = "性能设置", owner = self, fun = self.onQualitySettingClick });
	self.list:add({ label = "查看英雄", owner = self, fun = self.onCheckHero });
	
	self.btnArr = Array();
	for i = 1, self.list:getSize() do
		local posX = ((i - 1) % 4) * 165 - 245;
		local posY = 140 + Mathf.Floor((i - 1) / 4) * 60 * -1;
		local btn = UICreate.createButton(self.content, self.list[i].label, posX, posY, 141, 54);
		btn.name = "btn"..i;
		btn.siblingIndex = i + 10;
		btn:setStyle(14)
		btn.txt:setLocation(0, 0, 0)
		btn.txt.fontSize = 28
		btn:addClickFuntion(self.list[i].owner, self.list[i].fun);
		btn:setClickSound(nil);
		self.btnArr:add(btn);
	end

	if DataCenter.moveTest == nil or DataCenter.moveTest == false then
		self.cbMove.selected = false;
	else
		self.cbMove.selected = true;
	end

	if DataCenter.mapMesh == nil or DataCenter.mapMesh == false then
		self.cbMap.selected = false;
	else
		self.cbMap.selected = true;
	end

	self:updateServerTime();
	self:startTimer();
end

function Lua_DebugWindow:dispose()
	self:endTimer();
	TweenUtil.getInstance():stop(self.content);

	if self.list ~= nil then
		while self.list:getSize() > 0 do
			local obj = self.list:remove(1);
			obj.label = nil;
			obj.owner = nil;
			obj.fun = nil;
		end
		self.list:clear();
		self.list = nil;
	end

	if self.outPutPanel ~= nil then
		self.outPutPanel:dispose();
		self.outPutPanel = nil;
	end

	if self.btnArr ~= nil then
		self.btnArr:dispose();
		self.btnArr:clear();
		self.btnArr = nil;
	end
	if self.emjioEff ~= nil then
		self.emjioEff:dispose();
		self.emjioEff = nil;
	end
	self:removeShowModel()
	self:superCall("dispose");
end

function Lua_DebugWindow:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_DebugWindow", 0.01, self, self.onTimer, nil, -1);
	end
end

function Lua_DebugWindow:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_DebugWindow:onTimer()
	self:updateServerTime();
	self:onDebugDrag()
end

function Lua_DebugWindow:updateServerTime()
	if DataCenter.roleData then
		self.serverTime.text = "开服天数："..DataCenter.roleData.open_days.."\n服务器时间："..Lua_TimeTransform.transSeconds7(DataCenter.roleData.serverTime)
	end
end

function Lua_DebugWindow:onMouseDownHandle(go)
	self.clickTime = getTime();
	self.canDrag = true;
	self.startMouseX = CommonUtil.mousePositionX;
	self.startMouseY = CommonUtil.mousePositionY;
end

function Lua_DebugWindow:onMouseUpHandle(go)
	self.canDrag = false;
	if PlayerData.instance.uiShowState == 0 and getTime() - self.clickTime < 4 then
		MsgUtil.callFunc("UI_SHOW_STATE");
	end
end

function Lua_DebugWindow:onDebugDrag()
	if self.canDrag ~= true then
		return
	end

    local dx = CommonUtil.mousePositionX - self.startMouseX;
    local dy = CommonUtil.mousePositionY - self.startMouseY;
    self.startMouseX = CommonUtil.mousePositionX;
    self.startMouseY = CommonUtil.mousePositionY;

    local vec = self.content.transform.localPosition;
    local targetX = vec.x + dx;
    local vw = UnityEngine.Screen.width / GlobalVar.scaleRatio;
    if targetX < -(vw - self.w)/2 or targetX > (vw - self.w)/2 then
    	return;
    end

    local targetY = vec.y + dy;
    local vh = UnityEngine.Screen.height / GlobalVar.scaleRatio;
    if targetY < -(vh - self.h)/2 or targetY > (vh - self.h)/2 then
    	return;
    end

    LuaUtil.setObjPos(self.content, targetX, targetY, vec.z);
end

function Lua_DebugWindow:onBtnSendClick(go)
	local str = self.inputText.text;
	if str == "" then
		return;
	end

	if str == "A6D2D735" then
		Lua_WindowUtil.openWin("Lua_DebugWindow");
		return;
	end
	if str == "BA82821A" then
		Lua_MsgUtil.callFunc("SHOW_LOG_CHANGE");
		return;
	end
	if str == "65FACA33" then
		DataCenter.showVersion = true;
		return;
	end
	if str == "5BEB2EC8" then
		Lua_MsgUtil.callFunc("SHOW_FPS", true);
		return;
	end

	local arr = string.split(str, " ");
	if arr[1] == "guide" then
		--Lua_WindowUtil.openWin("Lua_GuideWindow", nil, tonumber(arr[2]));
		return;
	elseif arr[1] =="shadowOn" then
		MsgUtil.callFunc("SHADOW_ON", tonumber(arr[2]));
	elseif arr[1] =="shadowOff" then
		MsgUtil.callFunc("SHADOW_OFF");
	elseif arr[1] == "act" then
		ActingManager.getInstance():startAct(tonumber(arr[2]));
	end

	local len = arr:getSize();
	if len > 0 then
		local cmd = ProtoPublic_pb.Proto10111999();
		cmd.cmd_name = tostring(arr[1]);
		if len > 1 then
			cmd.param1 = tonumber(arr[2]);
		end
		if len > 2 then
			cmd.param2 = tonumber(arr[3]);
		end
		if len > 3 then
			cmd.param3 = tonumber(arr[4]);
		end
		if len > 4 then
			cmd.param4 = tonumber(arr[5]);
		end
		sendMsg(10111999, cmd);
	end
end

function Lua_DebugWindow:onMoveBoxClick(state)
	DataCenter.moveTest = state;
end

function Lua_DebugWindow:onMapBoxClick(state)
	-- DataCenter.mapMesh = state;
	self.boomState = not self.boomState;
	if self.boomState then
		MsgUtil.callFunc("BLOOM_ON", "testprofile");
	else
		MsgUtil.callFunc("BLOOM_OFF");
	end
end

function Lua_DebugWindow:onGcClick(go)
	LuaGC();
	LanUtil.systemGcCollect();
	OperateAlert.show("GC");
end

function Lua_DebugWindow:onOpenGM(go)
	Lua_WindowUtil.openWin("Lua_TestGMWindow", Lua_WinParam.ACTION_OPEN);
	self:hide();
end

function Lua_DebugWindow:onCameraInfoClick(go)
	MsgUtil.callFunc("SHOW_CAM_INFO");
end

function Lua_DebugWindow:onCameraLookAtClick(go)
	MsgUtil.callFunc("SHOW_CAM_LOOKAT");
end

function Lua_DebugWindow:onGetMapPosClick()
	Lua_WindowUtil.openWin("Lua_DebugMapPosWindow");
end

function Lua_DebugWindow:onPackageInfo()
	OperateAlert.show("包号:"..getPackNum().."   渠道:"..getChannelName());
end

function Lua_DebugWindow:onMsgOutClick(go)
	if self.outPutPanel == nil then
		self.outPutPanel = Lua_DebugOutputPanel.new(self.content);
		self.outPutPanel:setLocation(0, -530, 0);
	end

	if self.outPanelState == true then
		self.outPanelState = false;
		self.outPutPanel:setEnable(false);
	else
		self.outPanelState = true;
		self.outPutPanel:setEnable(true);
	end
	self:updateWindowDepth();
end

function Lua_DebugWindow:updateLuaFile(go)
	local str = self.inputText.text;
	if LanUtil.IsNullOrEmpty(str) then
		return;
	end

	local arr = string.gsub(str, "^%s*(.-)%s*$", "%1");
	LuaUtil.RefreshLuaFile(arr);
	updateRequire(arr);
	Lua_ProxyManager.updateSingleProxy(arr);
end

function Lua_DebugWindow:onColorChange(go)
	local str = self.inputText.text;
	if LanUtil.IsNullOrEmpty(str) then
		return;
	end
	print(Lua_ColorDefine.transColor(str));
end

function Lua_DebugWindow:onPopupWinTest(go)
	Lua_WindowUtil.openWin("ClickEffectWindow");
end

function Lua_DebugWindow:onSaveMsgTxt()
	local bWriteMsg = GlobalVar.bWriteMsg;
	GlobalVar.bWriteMsg = not bWriteMsg;
	local btn = self.btnArr[self.msgSaveBtnIdx];
	if GlobalVar.bWriteMsg then
		btn.label = "消保消息";
	else
		btn.label = "保存消息";
	end
end

function Lua_DebugWindow:onCameraDrag()
	local cameraViewHandle = GlobalVar.cameraViewHandle;
	if cameraViewHandle == nil then
		return;
	end
	
	DataCenter.bCameraDragRange = not DataCenter.bCameraDragRange;
	local btn = self.btnArr[self.camDragBtnIdx];
	if DataCenter.bCameraDragRange then
		btn.label = "镜头还原";
		-- cameraViewHandle:updateLimitAngle(0, 360, cameraViewHandle.currentPanAngle, cameraViewHandle.currentPanAngle);
		-- cameraViewHandle:updateLimitAngle(cameraViewHandle.currentTiltAngle, cameraViewHandle.currentTiltAngle, 0, 360);
		cameraViewHandle:updateLimitAngle(0, 360, 0, 360);
        cameraViewHandle:updateLimitDistance(0, 100000);
        LuaUtil.updateMapDragArea(100000, 100000);
	else
		btn.label = "镜头解除";
		CameraControl.Instance:updateToDefault(Scene3DManager.instance.curShowSceneId, true);
	end
end

function Lua_DebugWindow:onSetQualityLv()
	local lv = DeviceQuality.instance.qualityLevel;
	if lv <= 0 or lv >= 6 then
		lv = 1;
	else
		lv = lv + 1;
	end
	
	PlayerPrefsUtil.instance.qualityLevel = lv;
	OperateAlert.show("渲染品质等级为：" .. lv);
end

function Lua_DebugWindow:onDayOrNightChange()
	MsgUtil.callFunc("changeDayOrNightHandler");
end

function Lua_DebugWindow:onSceneChange()
	if self.inputText.text ~= nil then
		local sceneId = tonumber(self.inputText.text);
		if sceneId ~= nil then
			Scene3DManager.instance:OpenSceneBySceneId(sceneId, 0, self, self.onSceneShow, nil);
		end
	end
end

function Lua_DebugWindow:onSceneShow()
	print("Lua_DebugWindow onSceneShow")
end

function Lua_DebugWindow:onPlayFightRecords()
	self:hide();
	Lua_WindowUtil.openWin("Lua_FightDebugWindow");
end

function Lua_DebugWindow:onHideUICamera()
	MsgUtil.callFunc("UI_SHOW_STATE");
end

function Lua_DebugWindow:onOpenPostEff()
	MsgUtil.callFunc("BLOOM_ON", self.inputText.text);
end

function Lua_DebugWindow:onHidePostEff()
	MsgUtil.callFunc("BLOOM_OFF");
end

function Lua_DebugWindow:onOpenTestWin()
	Lua_WindowUtil.openWin("Lua_AllEntranceWindow");
	self:hide();
end

function Lua_DebugWindow:onOutputMemoryAsset()
	local cmd = ProtoPublic_pb.Proto10111999();
	cmd.cmd_name = "add_hero";

	local config = getConfig("hero")
	for k,v in pairs(config) do
		if v.is_shield ~= 1 and v.is_monster ~= 1 then
			cmd.param1 = k;
			cmd.param2 = v.max_star;
			cmd.param3 = getConfig("hero_star", v.max_star, "add_lvl_limit");
			sendMsg(10111999, cmd);
		end
	end
end

function Lua_DebugWindow:onScreenResolution()
	Lua_WindowUtil.openWin("Lua_ScreenResolutionWindow", Lua_WinParam.ACTION_OPEN);
	self:hide();
end

function Lua_DebugWindow:onScreenAdapter()
	Lua_WindowUtil.openWin("Lua_ScreenAdapterChangeWindow", Lua_WinParam.ACTION_OPEN);
	self:hide();
end

function Lua_DebugWindow:onStopWander()
	local btn = self.btnArr[10];
	local pid = tonumber(self.inputText.text);
	if DataCenter.mainLineSceneController.bStopWander ~= true then
		btn.label = "开始漫游";
		DataCenter.mainLineSceneController:stopWander(pid);
	else
		btn.label = "暂停漫游";
		DataCenter.mainLineSceneController:continueWander();
	end
end

function Lua_DebugWindow:onShowError()
	Lua_MsgUtil.callFunc("SHOW_LOG_CHANGE");
end

function Lua_DebugWindow:onShowFPS()
	if self.bShowFps == nil then
		self.bShowFps = true;
	else
		self.bShowFps = not self.bShowFps;
	end
	Lua_MsgUtil.callFunc("SHOW_FPS", self.bShowFps);
end

function Lua_DebugWindow:onShowRenderStats()
	if self.bShowRenderStats == nil then
		self.bShowRenderStats = true;
	else
		self.bShowRenderStats = not self.bShowRenderStats;
	end
	LuaUtil.showRenderStats(self.bShowRenderStats);
end

function Lua_DebugWindow:onShowPowerStats()
	if self.bShowPowerStats == nil then
		self.bShowPowerStats = true;
	else
		self.bShowPowerStats = not self.bShowPowerStats;
	end
	LuaUtil.showAndroidPower(self.bShowPowerStats);
end


-- function Lua_DebugWindow:onWaterWave()
-- 	if self.wwe == 1 then
-- 		self.wwe = 0;
-- 		MsgUtil.callFunc("REMOVE_POST_EFFECT", 2);
-- 	else
-- 		self.wwe = 1;
-- 		MsgUtil.callFunc("ADD_POST_EFFECT", 2);
-- 	end
-- end

-- function Lua_DebugWindow:onRadialBlur()
-- 	if self.rbe == 1 then
-- 		self.rbe = 0;
-- 		MsgUtil.callFunc("REMOVE_POST_EFFECT", 1);
-- 	else
-- 		self.rbe = 1;
-- 		MsgUtil.callFunc("ADD_POST_EFFECT", 1);
-- 	end
-- end

function Lua_DebugWindow:onBackstageActivityTest(go)
    DataCenter.backstageActData:backstageActivityTest();
end

function Lua_DebugWindow:onMainlineDebug(go)
	Lua_WindowUtil.openWin("Lua_MainLineDebugWindow", Lua_WinParam.ACTION_OPEN);
	self:hide();	
end

function Lua_DebugWindow:onAddNiuQuEff(go)
	local sceneId = DataCenter.sceneData.curSceneId;
	local sc = Lua_SceneConfigData.getSceneConfig(sceneId);
	if sc == nil then
		return;
	end

	local sceneResId = sc.sceneResId;
	if sceneResId == nil then
		return;
	end

	local sl = getConfig("tb_scene_res", sceneResId, "sceneLayer");
	print("sl = ", sl);
	local sd = SceneEffectData();
    sd.roleId = getTime();
    sd.sceneId = sceneId;
    sd.fightRecordId = DataCenter.fightData.curPlayFightRecordId;
    sd.kind = Lua_ThingDefine.SCENE_EFFECT;
    sd.px = 0;
    sd.py = 0;
    sd.pz = 0;
    sd.canBeClick = false;
    sd.effectFile = "libai_showeff";
    sd.effectName = "libai_showeff";
    sd.showShadow = false;
    sd.isShowName = false;
    sd.toLand = false;
    sd.rotX = 0;
    sd.rotY = 0;
    sd.rotZ = 0;
    sd.scaX = 1;
    sd.scaY = 1;
    sd.scaZ = 1;
    if sl == nil then
    	sd.layer = 0;
    else
    	sd.layer = sl;
    end
    ThingUtil.instance:addSceneEffect(sd, true);
end

function Lua_DebugWindow:onFuncOpen()
	local cmd = ProtoPublic_pb.Proto10111999();
	cmd.cmd_name = "func_open";
	sendMsg(10111999, cmd);
end

function Lua_DebugWindow:onVecDis()
	Lua_WindowUtil.openWin("Lua_VecDistanceWindow", Lua_WinParam.ACTION_OPEN);
	self:hide();
end

function Lua_DebugWindow:onOutputResInfo()
	LoadManager.getInstance():outputMemoryAsset();
end

function Lua_DebugWindow:onPlaySound()
	local str = self.inputText.text;
	if LanUtil.IsNullOrEmpty(str) then
		return;
	end
	DataCenter.audioManager:play(str);
end

function Lua_DebugWindow:onChangeUrp()
	local str = self.inputText.text;
	if LanUtil.IsNullOrEmpty(str) then
		return;
	end
	URPResManager.instance:setUrpAsset(str); -- UniversalRenderPipelineAsset_hight
end

function Lua_DebugWindow:onMainlinePreView()
	if DataCenter.mainLinePreViewController == nil then return; end
	if DataCenter.mainLinePreViewController.bOpenPreView then
		DataCenter.mainLinePreViewController.bOpenPreView = false;
	else
		DataCenter.mainLinePreViewController.bOpenPreView = true;
	end
end

-- 引导测试
function Lua_DebugWindow:onGuideTestClick()
	Lua_WindowUtil.openWin("Lua_GuideTestWindow", Lua_WinParam.ACTION_OPEN);
	self:hide();
end

function Lua_DebugWindow:onGuideCloseClick()
	local btn = self.btnArr[self.guideCloseBtnIdx];
	if btn == nil then
		return;
	end

	DataCenter.guideData.bOpenGuide = not DataCenter.guideData.bOpenGuide;
	btn.label = DataCenter.guideData.bOpenGuide and "关闭引导" or "开启引导";
	Lua_WindowUtil.openWin("Lua_GuideWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_DebugWindow:onEmjioClick()
	-- if not DataCenter.bConfigLoaded then
	-- 	return;
	-- end

	-- local str = self.inputText.text;
	-- if LanUtil.IsNullOrEmpty(str) then
	-- 	return;
	-- end
	
	-- local cfg = getConfig("chat_emoji", str);
	-- if cfg == nil then
	-- 	OperateAlert.show("无此id表情");
	-- 	return;
	-- end
	-- if self.emjioEff == nil then
    --     self.emjioEff = UICreate.createUIEffect(self.content, nil, nil, 90, -172);
    -- end
    -- self.emjioEff:setUrl(cfg.url, cfg.matName);

    local sceneId = DataCenter.heroLineupData:getLineUpSceneId(Lua_HeroUtil.LINEUP_MAIN_TYPE);
    DataCenter.preLoadData:preShowScene("Lua_HeroLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
    Lua_WindowUtil.openWin("Lua_MainLineFightWinWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_DebugWindow:onSceneShow(param)
    local arr = DataCenter.heroLineupUtil:getLineupTabArr()
    Lua_WindowUtil.openWin("Lua_HeroLineupWindow", Lua_WinParam.ACTION_OPEN, arr);
end

function Lua_DebugWindow:onRedPointTreeClick()
	Lua_WindowUtil.openWin("Lua_RedPointTreeWindow", Lua_WinParam.ACTION_OPEN);
	self:hide();
end

function Lua_DebugWindow:onQualitySettingClick()
	Lua_WindowUtil.openWin("Lua_QualitySettingWindow", Lua_WinParam.ACTION_OPEN);
	self:hide();
end

function Lua_DebugWindow:onCheckHero(go)
	local str = self.inputText.text
	if LanUtil.IsNullOrEmpty(str) then
		return
	end

	local heroId = tonumber(str)
	local heroVo = Lua_HeroVo.new(heroId)
	DataCenter.preLoadData:preShowModelScene("Lua_DebugWindow_showHero", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onShowModel, heroVo, heroVo)	
end

function Lua_DebugWindow:onShowModel(param, modelScenePanel)
	param.modelScenePanel = modelScenePanel
	Lua_WindowUtil.openWin("Lua_RecruitShowSingleHeroWindow", Lua_WinParam.ACTION_OPEN, param)
end

function Lua_DebugWindow:removeShowModel()
    DataCenter.preLoadData:removeBySign("Lua_DebugWindow_showHero", self, self.onShowModel)
end

function Lua_DebugWindow:onDevelopDebugTest()
	self:hide();
	Lua_WindowUtil.openWin("Lua_DevelopDebugWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_DebugWindow:onSpineEffAni(st, aniName, trackIdx, loop, evtName, time)
	if st == Lua_SpineEventType.Complete then
		if aniName == "loop_1" then
			self.showTestEffPlayIdx = self.showTestEffPlayIdx + 1;
			if self.showTestEffPlayIdx > 5 then
				self.showTestEffPlayIdx = 0;
				self.showTestEff:setSpineAniState(0, "loop_2");
			end
		elseif aniName == "loop_2" then
			self.showTestEffPlayIdx = self.showTestEffPlayIdx + 1;
			if self.showTestEffPlayIdx > 4 then
				self.showTestEffPlayIdx = 0;
				self.showTestEff:setSpineAniState(0, "loop_3");
			end
		elseif aniName == "loop_3" then
			self.showTestEffPlayIdx = self.showTestEffPlayIdx + 1;
			if self.showTestEffPlayIdx > 3 then
				self.showTestEffPlayIdx = 0;
				self.showTestEff:setSpineAniState(0, "loop_4");
			end
		elseif aniName == "loop_4" then
			self.showTestEffPlayIdx = self.showTestEffPlayIdx + 1;
			if self.showTestEffPlayIdx > 2 then
				self.showTestEffPlayIdx = 0;
				self.showTestEff:setSpineAniState(0, "loop_5");
			end
		elseif aniName == "loop_5" then
			self.showTestEffPlayIdx = self.showTestEffPlayIdx + 1;
			if self.showTestEffPlayIdx > 10 then
				self.showTestEffPlayIdx = 0;
				self.showTestEff:setSpineAniState(0, "loop_1");
			end
		end
	end
end