Lua_ScreenResolutionWindow = class("Lua_ScreenResolutionWindow", Lua_Window);
function Lua_ScreenResolutionWindow:ctor()
	self:superCall("ctor");
	
	self.windowName = "Lua_ScreenResolutionWindow";
	self.skinName = "ScreenResolutionWindow_skin";
end

function Lua_ScreenResolutionWindow:buildShowItem()
	self:superCall("buildShowItem");

	local w = UnityEngine.Screen.width;
	self.inputWidth.text = w;
	self.inputHeight.text = UnityEngine.Screen.height;
	self.btnComfirm:addClickFuntion(self, self.onBtnConfirmClick);

	local btnTxt = UICreate.createLabel(self.content, "等比调节分辨率", -176, -70, 300, 40, 24);
	btnTxt.colorStr = Lua_ColorDefine.transColorStr("000000");

	self.slider = Lua_SliderProgressBar.new(self.content, "role_atlas", "ui_grxx_progress_001_b", "ui_grxx_progress_001_f", "ui_grxx_progress_001_t", 466, 34);
	self.slider:setLocation(80, -65, 0);
	self.slider:setValue(100, 0, 200);
	self.slider:setCallBack(self, self.updateResolution);
end

function Lua_ScreenResolutionWindow:dispose()
	self:superCall("dispose");
end

function Lua_ScreenResolutionWindow:onBtnConfirmClick(go)
	local w = tonumber(self.inputWidth.text);
	if w == nil then w = 450; end
	local h = tonumber(self.inputHeight.text);
	if h == nil then h = 900; end
	LuaUtil.setScreenResolution(w, h);
	self:hide();
end

function Lua_ScreenResolutionWindow:updateResolution(count)
	local w = 450 + count - 100;
	local h = (w * 900) / 450;
	self.inputWidth.text = w.."";
	self.inputHeight.text = h.."";
	LuaUtil.setScreenResolution(w, h);
end