Lua_TestItemSelectWindow = class("Lua_TestItemSelectWindow", Lua_Window);
function Lua_TestItemSelectWindow:ctor()
    self:superCall("ctor");

    self.w = 703;
    self.h = 800;
    self.layer = MainWinDefine.MAX_TOP_LAYER;
    self.windowName = "Lua_TestItemSelectWindow";
    self.showBlackMask = true;
    self.showWinBg = true;
    self.winBgAtlas = "common_altas_1";
    self.winBgSprite = "ui_common_window_007";
    self.showClose = true;
    self.btnClosePosX = 300;
    self.btnClosePosY = 355;
end

function Lua_TestItemSelectWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.noticeTx = UICreate.createLabel(self.content, "筛选：", -250, 290, 100, 40, 26);
    self.noticeTx.pivot = Lua_WindowUtil.getPivot(4);
    self.noticeTx.alignmentValue = 4;
    self.noticeTx.horizontalOverflowValue = 1;
    self.noticeTx.colorStr = Lua_ColorDefine.transColor("846651");

    self.inputBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_edit_001", 0, 290, 400, 40);

    self.searchInput = UICreate.createInput(self.content, "", 5, 290, 390, 40, 26);
    self.searchInput.alignmentValue = 3;
    self.searchInput.colorStr = Lua_ColorDefine.transColor("846651");
    self.searchInput.defaultText = "输入关键字进行筛选";
	self.searchInput:onChange(self, self.onSearch);
    self.searchInput:ActivateInputField();

    self.dragList = Lua_DragList.new(self.content, 620, 600, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_TestItemSelectItem, 310, 50, 2);
    self.dragList:setCellSpacing(0, 10);
    self.dragList:setLocation(0, -50);
end

function Lua_TestItemSelectWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    self:superCall("dispose");
end

function Lua_TestItemSelectWindow:showWin(param)
	self:superCall("showWin", param);

	self.showArr = Array();
	local config = getConfig(param);
	for k, v in pairs(config) do
		self.showArr:add(v);
	end
	self:updateShowList();
end

function Lua_TestItemSelectWindow:onSearch()
	self:updateShowList(self.searchInput.text);
end

function Lua_TestItemSelectWindow:updateShowList(str)
	if strIsNullOrEmpty(str) then
		self.dragList:setArrayData(self.showArr);
	else
		local arr = Array();
		local v;
		for i = 1, self.showArr:getSize() do
			v = self.showArr[i];
			if not strIsNullOrEmpty(v.name) and string.find(v.name, str) ~= nil then
				arr:add(v);
			end
		end
		self.dragList:setArrayData(arr);
	end
	self.dragList:moveToIndex(1, true);
end




















Lua_TestItemSelectItem = class("Lua_TestItemSelectItem", Lua_ListCell);
function Lua_TestItemSelectItem:ctor(p)
    self:superCall("ctor", p);
    
end

function Lua_TestItemSelectItem:buildShowItem()
    self:superCall("buildShowItem");

    self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_edit_001", 0, 0, 300, 50);

    self.txt = UICreate.createLabel(self.content, "", 0, 0, 280, 40, 26);
    self.txt.pivot = Lua_WindowUtil.getPivot(4);
    self.txt.alignmentValue = 4;
    self.txt.verticalOverflowValue = 1;
    self.txt.colorStr = Lua_ColorDefine.transColor("846651");
end

function Lua_TestItemSelectItem:dispose()
    self:superCall("dispose");
end

function Lua_TestItemSelectItem:setData(data)
    self.data = data;
    self.txt.text = data.name;
end

function Lua_TestItemSelectItem:onPressClick()
    Lua_MsgUtil.callFunc("TEST_ITEM_SELECT", self.data);
    Lua_WindowUtil.openWin("Lua_TestItemSelectWindow", Lua_WinParam.ACTION_CLOSE);
end