Lua_TestRedPointWindow = class("Lua_TestRedPointWindow", Lua_Window)

function Lua_TestRedPointWindow:ctor()
	self:superCall("ctor");

	self.w = 700;
	self.h = 900;
	self.showClose = true;
    self.isClickClose = true;
	self.showWinBg = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";

	self.windowName = "Lua_TestRedPointWindow";
end

function Lua_TestRedPointWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btn1 = UICreate.createButton(self.content, "红点1", 0, 300, 120, 45);
	self.btn1.name = "btn1";
	self.btn1:setGray(true);
	self.btn1:addClickFuntion(self, self.onBtnClick);

	self.btn2 = UICreate.createButton(self.content, "红点2", 0, 240, 120, 45);
	self.btn2.name = "btn2";
	self.btn2:setGray(true);
	self.btn2:addClickFuntion(self, self.onBtnClick);

	self.btn3 = UICreate.createButton(self.content, "控制红点2", 0, 50, 120, 45);
	self.btn3.name = "btn3";
	self.btn3:addClickFuntion(self, self.onBtnClick);

	DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.MailTab, 2);
	self.redPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.Mail);
	self.redPoint:setLocation(0, 150);

	self.redPoin2 = Lua_RedPointIcon.new(self.content);
	self.redPoin2:createRedPointImg();
	-- self.redPoin2:createRedPointEff();
	self.redPoin2:updateRedPointShow(true, 1);
	self.redPoin2:setLocation(0, 110);

	self:addLuaEvent("RedPoint_Update_State", self, self.updateBtnShow);
end

function Lua_TestRedPointWindow:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.redPoint2 ~= nil then
		self.redPoint2:dispose();
		self.redPoint2 = nil;
	end

	self:superCall("dispose");
end

function Lua_TestRedPointWindow:onBtnClick(go)
	if go.name == "btn3" then
		if self.btnNum3 == nil then
			self.btnNum3 = 0;
		end
		self.btnNum3 = self.btnNum3 + 1;
		DataCenter.redPointData:updateRedPointShowNum(Lua_RedPointList.MailTab, self.btnNum3);
	end
end

function Lua_TestRedPointWindow:updateBtnShow(id)
	local vo = DataCenter.redPointData:getRedPointVoById(id)
	if vo ~= nil then
		if id == Lua_RedPointList.Mail then
			self.btn1:setGray(not vo.showState);
			self.btn1.label = "红点1 " .. vo.showNum;
		elseif id == Lua_RedPointList.MailTab then
			self.btn2:setGray(not vo.showState);
			self.btn2.label = "红点2 " .. vo.showNum;
		end
	end
end