checkRequire("Lua_ScrollBoard");
Lua_TestScrollViewWindow = class("Lua_TestScrollViewWindow", Lua_Window)
function Lua_TestScrollViewWindow:ctor()
	self:superCall("ctor");

	self.w = 703;
	self.h = 900;
	self.windowName = "Lua_TestScrollViewWindow";
	self.layer = MainWinDefine.MAX_TOP_LAYER;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";
	self.showWinBg = true;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showClose = true;
	self.btnClosePosX = 305;
	self.btnClosePosY = 405;
	self.showCloseText = true;
	self.closeTextPosY = -460;
end

function Lua_TestScrollViewWindow:buildShowItem()
	self:superCall("buildShowItem");
	-- self:testEffect()
 	-- self:testModel()
 	-- self:testDragContainer();
 	-- self:testDragList();
 	-- self:testDrangList();
 	-- self:testDrangListContainer();
 	-- self:testDragCustomBtnList()
 	--self:testCirculate()
 	--self:testDragContainerClone();
 	--self:testRoundList();
 	self:testScrollBoard();
end

function Lua_TestScrollViewWindow:dispose()
    if self.parentDragList ~= nil then
        self.parentDragList:dispose();
        self.parentDragList = nil;
    end
    if self.dragContainer ~= nil then
        self.dragContainer:dispose();
        self.dragContainer = nil;
    end
    if self.dragListClone ~= nil then
    	self.dragListClone:dispose();
    	self.dragListClone = nil;
    end
    if self.roundList ~= nil then
    	self.roundList:dispose();
    	self.roundList = nil;
    end
    if self.scrollBoard ~= nil then
    	self.scrollBoard:dispose();
    	self.scrollBoard = nil;
    end
	self:superCall("dispose");
end

function Lua_TestScrollViewWindow:onScreenResize()
	self:superCall("onScreenResize");
	if self.dragContainer ~= nil then
		self.dragContainer:setContentRect(510, 620 + self.adaptHeight);
	end

	if self.parentDragList ~= nil then
		self.parentDragList:setContentRect(500, 620 + self.adaptHeight);
	end
end

function Lua_TestScrollViewWindow:testDragContainer()
	self.dragContainer = Lua_DragContainer.new(self.content, 112, 600, Lua_AxisDefine.Vertical);
	-- self.dragContainer.canLongPress = true;
	self.dragContainer.tweenId = 1006;
	self.dragContainer:setCellSpacing(0, 0);

	for i = 1, 30 do
		self.dragContainer:addSubContainer(Lua_TestDragContainerItem, i, false, 0);
	end
	self.dragContainer:updateChildPos();
	self.dragContainer:moveToIndex(1, true);
	self.dragContainer:setSelected(1);
end

function Lua_TestScrollViewWindow:testDragList()
	self.dragList = Lua_DragList.new(self.content, 560, 560, Lua_AxisDefine.Vertical);
	-- self.dragList.canLongPress = true;
	self.dragList.tweenId = 1006;
	self.dragList:setListCell(Lua_TestDragItem, 112, 112, 5);

	local arr = Array();
	for i = 1, 30 do
		arr:add(i)
	end
	self.dragList:setArrayData(arr);
	self.dragList:moveToIndex(1, true);
	self.dragList:setSelected(1);
end

--镶嵌列表测试
function Lua_TestScrollViewWindow:testDrangList()
	--1、父列表垂直拖拽。子列表水平拖拽
	self.parentDragList = Lua_DragList.new(self.content,520, 620 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.parentDragList:setListCell(Lua_ParentVerticalCell, 160, 160, 3);
	self.parentDragList:setCellPivot(1);
	self.parentDragList:setSubOffect(10,0);
	self.parentDragList:setCellSpacing(10, 10);
	self.parentDragList:setLocation(0, 0);
	-- self.parentDragList.canLongPress = true;

	--2、父列表水平拖拽。子列表垂直拖拽
	-- self.parentDragList = Lua_DragList.new(self.content,630, 530, Lua_AxisDefine.Horizontal);
	-- self.parentDragList:setListCell(Lua_ParentHorizontalCell, 170, 170, 3);
	-- self.parentDragList:setCellPivot(1);
	-- self.parentDragList:setCellSpacing(20, 10);
	-- self.parentDragList:setLocation(0, 0);

	local itemList = {{201000001,201000001,201000001,201000001},{201000001,201000001},{201000001,201000001},{201000001,201000001},{201000001,201000001},{201000001,201000001},{201000001,201000001}}
	local arr = Array();
    for i=1,7 do
    	local arr1 = Array();
    	local list = itemList[i];
    	local vo;
    	for j=1,#list do
    		vo = Lua_ToolVo.new(list[j]);
    		arr1:add(vo);
    	end
    	arr:add({index = i,arr = arr1});
    end
    self.parentDragList:setArrayData(arr);
	-- self.parentDragList:moveToIndex(4, false,false);
end

--容器列表测试
function Lua_TestScrollViewWindow:testDrangListContainer()
	local data = 0;
	local offsetVal = 0;
	-- self.dragContainer = Lua_DragContainer.new(self.content, 507, 620, Lua_AxisDefine.Vertical);
	-- self.dragContainer:setLocation(0, 0);
	-- self.dragContainer:setCellSpacing(20, 10);

	self.dragContainer = Lua_DragContainer.new(self.content, 510, 620 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragContainer:setLocation(0, 0);
	self.dragContainer:setCellPivot(5);
	self.dragContainer:setCellSpacing(20, 10);

	-- self.dragContainer:addSubContainer(Lua_TestDragContainerItem, data, true, offsetVal);
	local offsetVal = 0;
	for i=1, 30 do
		if i%2 == 0 then
			offsetVal = 0;
		else
			offsetVal = 0;
		end
		self.dragContainer:addSubContainer(Lua_TestDragContainerItem, i, false, offsetVal)
	end
	self.dragContainer:updateChildPos();

	self.dragContainer:moveToIndex(1, false, false);
end

-- 自适应下拉页签测试
-- Lua_MainCell和Lua_SubCell，的self.data都是父类的属性（只读）
-- data里面的mainIndex和subIndex，在创建的时候会赋值，这两个字段传入的时候别用
-- subData字段保留使用，Lua_SubCell的data
-- childrenList里面包含MainCell和SubCell
-- 因为统一设置posY，所有offsetY的值“必须”保持一致（目前是这样）
-- offsetY等于Lua_DragCustomBtnList的宽度的一半
-- 垂直设置cellHeight，对应cell背景大小
-- 没有水平
function Lua_TestScrollViewWindow:testDragCustomBtnList()
	self.btnList = Lua_DragCustomBtnList.new(self.content, Lua_AxisDefine.Vertical, 600, 500);
	self.btnList:setLocation(0, 0, 0);
	self.btnList:setMainCell(Lua_MainCell, 0, 135, 0, 250);
	self.btnList:setSubCell(Lua_SubCell, 0, 100, 0, 250);
	self.btnList.clickDrawBack = true;

	local arr = Array();
	local subData;
	for i = 1, 10 do
		subData = Array();
		for j = 1, i do
			subData:add({ subIdx = j * 10 });
		end
		arr:add({ mainIdx = i, subData = subData });
	end
	self.btnList:setData(arr);
end

--模型测试
function Lua_TestScrollViewWindow:testModel()
	self.groupImage = UICreate.createModeEffGroupImage(self.content, 0, 700, 720, 720);
	
    self.showModel = ModelEffComponent(self.groupImage.root);
	self.showModel:setRot(90);
	self.showModel:setLocation(0.6, 0, 0);
	self.showModel:setScale(0.6);
	self.showModel:setUrl("/model/102000505_low", "102000505_low");

	self.showModel1 = ModelEffComponent(self.groupImage.root);
	self.showModel1:setRot(90);
	self.showModel1:setLocation(-0.6, 0, 0);
	self.showModel1:setScale(0.6);
	self.showModel1:setUrl("/model/102000505_low", "102000505_low");
end

--特效测试
function Lua_TestScrollViewWindow:testEffect()
	self.eff2 = UICreate.createModelEffImg(self.content, "/model/102000505_low", "102000505_low", 0, 0, 0, 0);
	self.eff2:setCamField(1, 1, 100, true);
	self.eff2:setCamPos(0, 1, -10);
	self.eff2:setModelEffDir(180);
	self.eff2.canRot = true;

	self.testBtn = UICreate.createButton(self.content, "切换动作", 0, 0, 120, 50);
    self.testBtn:setLocation(0, -350, 0);
    self.testBtn:addClickFuntion(self, self.onBtnClick);

    -- self.eff3 = UICreate.createModelEffImg(self.content, "gui_redpoint", 200, 0, 0, 0);
end

function Lua_TestScrollViewWindow:onBtnClick()
	self.eff2:setAction(Mathf.Ceil(Mathf.Random(1, 3)));
end

function Lua_TestScrollViewWindow:testCirculate()
	self.circulateList = Lua_CirculateListClone.new(self.content, 660, 700, Lua_AxisDefine.Vertical)
	--self.circulateList.showCount = 5 -- 显示个数
	--self.circulateList.offsetPos = -80 -- 偏移值
	self.circulateList.needRegulate = true -- 校正
	self.circulateList:setLocation(0, 0);
	self.circulateList:setCell(Lua_CirculateTestItem, 150, 50)
	self.circulateList:setCirculate();
	--self.circulateList:setCellSpacing(20, 22.2)
	self.circulateList:setShowCount(8);

	local arr = Array()
	for i = 1, 50 do
		arr:add(i)
	end
	self.circulateList:setData(arr)
	--self.circulateList:moveToIndex(45)
end

function Lua_TestScrollViewWindow:testDragContainerClone()
	self.dragContainer = Lua_DragContainer.new(self.content, 720, 700, Lua_AxisDefine.Vertical);
	self.dragContainer:setCellSpacing(0, 40);
	self.dragContainer:setLocation(31, -45);
	self.dragContainer.tweenId = 2018
	--self.dragContainer.needRegulate = true;
	--self.dragContainer:setCirculate(350, Vector2(-300, 0));

	for i = 50, 1, -1 do
		self.dragContainer:addSubContainer(Lua_TestDragContainerItem, i);
	end
	self.dragContainer:updateChildPos();
end

function Lua_TestScrollViewWindow:testRoundList()
	self.roundList = Lua_RoundList.new(self.content, 680, 700, Lua_AxisDefine.Vertical);
	self.roundList:setCell(Lua_RoundTestItem, 204, 66);
	--self.roundList:setCellSpacing(0, 10);
	self.roundList.radius = 318;
	self.roundList:setShowCount(9);
	self.roundList.needRegulate = true;

	local arr = Array();
	for i = 1, 50 do
		arr:add(i);
	end
	self.roundList:setData(arr, true);

	self.roundList:moveToIndex(20);
end

function Lua_TestScrollViewWindow:testScrollBoard()
	self.scrollBoard = Lua_ScrollBoard.new(self.content, Lua_AxisDefine.Horizontal, 400, 200);
	self.scrollBoard:setListCell(Lua_ScrollBoardTestItem, 170, 170);
	self.scrollBoard.isLoop = false;
	self.scrollBoard:setCellSpacing(20, 0);
	--self.scrollBoard:setChangeScale(1, 0.8, 0.001);
	--self.scrollBoard:setChangeScale(1, 0.8, 0.001);
	self.scrollBoard:setChangeRot(0, 8, 1);
	self.scrollBoard:setChangePos(-50);

	local arr = Array();
	for i = 1, 10 do
		arr:add(i);
	end
	self.scrollBoard:setLuaArrayData(arr);
	--self.scrollBoard:moveToIndex(5, false);
end















--1、父列表垂直拖拽。子列表水平拖拽
Lua_ParentVerticalCell = class("Lua_ParentVerticalCell", Lua_ListCell);
function Lua_ParentVerticalCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_ParentVerticalCell:buildShowItem()
	self:superCall("buildShowItem");

    self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_button_041_n", 0, 0, 0, 0);
	self.bg.siblingIndex = 5;
	self.bg:SetDimensions(160, 160);
	-- self.bg.pivot = Lua_WindowUtil.getPivot(1);
	-- self.bg:setCellPivot(1);
	--self.bg:addClickFuntion(self, self.OnBgClick);

	self.text = UICreate.createLabel(self.content, "", 0, 0, 100, 35, 24);
	self.text.siblingIndex = 6;
	
	-- self.gameObject = UICreate.createGameObject(self.content,0,0,0);
	-- self.gameObject:AddComponent(typeof(UnityEngine.RectTransform));

	-- self.itemIcon = Lua_ItemIcon.new(self.gameObject);
 --    self.itemIcon:setCanClick(false);

	--子列表
	self.subDragList = Lua_DragList.new(self.content,367, 106, Lua_AxisDefine.Horizontal);
	self.subDragList:setListCell(Lua_SubDrangCell, 106, 106, 1);
	self.subDragList:setCellSpacing(20, 10);
	self.subDragList:setLocation(65, 10);
	self.subDragList:setRectPivot(5);
	self.subDragList:setCellPivot(1);

    self:setSubList(self.subDragList);
end

function Lua_ParentVerticalCell:onPressClick()
	print("点击了背景  1111111111",self.data.index);
	-- Lua_MsgUtil.callFunc("UPDATE_INFO");--事件派发写这里
end

function Lua_ParentVerticalCell:onSelectionChange(bool)
	-- print("点击了背景  1111111111",bool);
	self:superCall("onSelectionChange",bool);
	if bool then
		self.bg:setAltas("common_altas_1", "ui_common_button_041_p");
		-- Lua_MsgUtil.callFunc("UPDATE_INFO");--事件派发不要写这里
	else
		self.bg:setAltas("common_altas_1", "ui_common_button_041_n");
	end
end

function Lua_ParentVerticalCell:setData(data)
    if data == nil then
		return;
	end
	self.data = data;
	self.text.text = data.index;
	if self.subDragList~= nil then
	    self.subDragList:setArrayData(data.arr);
	    self.subDragList:moveToIndex(1,true);
	end
end

function Lua_ParentVerticalCell:dispose()
	if self.subDragList ~= nil then
		self.subDragList:dispose();
		self.subDragList = nil;
	end
	self.bg = nil;
	self.text = nil;
	self:superCall("dispose");
end








--1、父列表水平拖拽。子列表垂直拖拽
Lua_ParentHorizontalCell = class("Lua_ParentHorizontalCell", Lua_ListCell);
function Lua_ParentHorizontalCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_ParentHorizontalCell:buildShowItem()
	self:superCall("buildShowItem");

    self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_button_041_n", 0, 0, 0, 0);
	self.bg.siblingIndex = 5;
	self.bg:SetDimensions(170, 170);
	--self.bg:addClickFuntion(self, self.OnBgClick);

	self.text = UICreate.createLabel(self.content, "", 0, 0, 100, 35, 24);
	self.text.siblingIndex = 6;
    
    --子列表
	-- self.subDragList = Lua_DragList.new(self.content,103, 330, Lua_AxisDefine.Vertical);
	-- self.subDragList:setListCell(Lua_SubDrangCell, 106, 106, 1);
	-- self.subDragList:setCellSpacing(20, 10);
	-- self.subDragList:setLocation(0, 26);
	-- self.subDragList:setMouseEnable(false);
	-- self.subDragList:setRectPivot(5);
	-- self.subDragList:setCellPivot(1);

 --    self:setSubList(self.subDragList);
end

function Lua_ParentHorizontalCell:onPressClick()
	print("点击了背景  2222222222");
	-- Lua_MsgUtil.callFunc("UPDATE_INFO");--事件派发写这里
end

function Lua_ParentHorizontalCell:onSelectionChange(bool)
	self:superCall("onSelectionChange",bool);
	if bool then
		self.bg:setAltas("common_altas_1", "ui_common_button_041_p");
		-- Lua_MsgUtil.callFunc("UPDATE_INFO");--事件派发不要写这里
	else
		self.bg:setAltas("common_altas_1", "ui_common_button_041_n");
	end
end

function Lua_ParentHorizontalCell:setData(data)
    if data == nil then
		return;
	end
	self.data = data;
	self.text.text = data.index;
	if self.subDragList ~= nil then
	    self.subDragList:setArrayData(data.arr);
	    self.subDragList:moveToIndex(1,true);
	end
end

function Lua_ParentHorizontalCell:dispose()
	if self.subDragList ~= nil then
		self.subDragList:dispose();
		self.subDragList = nil;
	end
	self.bg = nil;
	self.text = nil;
	self:superCall("dispose");
end













Lua_SubDrangCell = class("Lua_SubDrangCell", Lua_ListCell);
function Lua_SubDrangCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_SubDrangCell:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setLocation(0, 0, 0);
    self.itemIcon:setCanClick(false);
end

function Lua_SubDrangCell:setData(data)
	self.data = data;
    if data == nil then
		return;
	end
	self.itemIcon:setData(data);
end

function Lua_SubDrangCell:onPressClick()
	print("点击了背景  Lua_SubDrangCell");
	DataCenter.packUtil:showItemInfo(self.data);
end

function Lua_SubDrangCell:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end


























Lua_TestDragContainerItem = class("Lua_TestDragContainerItem", Lua_DragContainerItem);
function Lua_TestDragContainerItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_TestDragContainerItem:buildShowItem()
    self:superCall("buildShowItem");
    self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_button_041_n", 0, 0, 30, 30);
	self.text = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 22);
	self.text.alignmentValue = 4;
end

function Lua_TestDragContainerItem:setData(data)
	self.data = data;
	--self.bg:SetDimensions(112, 112 + data);
	self.text.text = data;
end

-- function Lua_TestDragContainerItem:onSelectionChange(bSelect)
-- 	self:superCall("onSelectionChange", bSelect);
-- 	if bSelect then
-- 		self.bg:setAltas("common_altas_1", "ui_common_itembg_02");
-- 	else
-- 		self.bg:setAltas("common_altas_1", "ui_common_itembg_01");
-- 	end
-- end

function Lua_TestDragContainerItem:onPressClick()
	print("onPressClick", self.data);
	return true;
end

function Lua_TestDragContainerItem:onLongPressClick()
	print("onLongPressClick", self.data);
	return true;
end

function Lua_TestDragContainerItem:getWidth()
    --return self.bg.width;
    return 30;
end

function Lua_TestDragContainerItem:getHeight()
    --return self.bg.height;
    return 30;
end


























Lua_TestDragItem = class("Lua_TestDragItem", Lua_ListCell);
function Lua_TestDragItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_TestDragItem:buildShowItem()
    self:superCall("buildShowItem");
    self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_button_041_n", 0, 0, 30, 30);
	self.text = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 22);
	self.text.alignmentValue = 4;
end

function Lua_TestDragItem:setData(data)
	self.data = data;
	self.text.text = data;
end

function Lua_TestDragItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);
	if bSelect then
		self.bg:setAltas("common_altas_1", "ui_common_button_041_n");
	else
		self.bg:setAltas("common_altas_1", "ui_common_button_041_n");
	end
end

function Lua_TestDragItem:onPressClick()
	print("onPressClick", self.data);
	return true;
end

function Lua_TestDragItem:onLongPressClick()
	print("onLongPressClick", self.data);
	return true;
end










Lua_MainCell = class("Lua_MainCell", Lua_DragCustomBtnListCell);
function Lua_MainCell:ctor(p, btnType, cellWidth, cellHeight, offsetX, offsetY, skin)
	self:superCall("ctor", p, btnType, cellWidth, cellHeight, offsetX, offsetY, skin);

	-- print("Lua_MainCell", cellWidth, cellHeight, offsetX, offsetY);
end

function Lua_MainCell:buildShowItem()
	self:superCall("buildShowItem");

	self.banner = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_tips_001", 0, 0, 600, 135);
	self.rateIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_zjm_button_01", 200, 35, 0, 0);

	self.mainTxt = UICreate.createLabel(self.content, "", 0, 0, 500, 35, 30);
	self.mainTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.mainTxt.alignmentValue = 4;
end

function Lua_MainCell:updateData()
	self.mainTxt.text = LanUtil.formateStr("这是mainIndex为{1}的Lua_MainCell", self.data.mainIdx);
end

function Lua_MainCell:onPressClick()
	self:superCall("onPressClick");
end

function Lua_MainCell:setSelected(val)
	self:superCall("setSelected", val);

	print("mainIdx", self.data.mainIdx, val, self.scale);
	if val == true then
		-- 同一个选择返回是true
		-- if not self.scale == true then
		-- 	self.scale = true;
		-- 	self.rateIcon:setScale(1, -1, 1);
		-- else
		-- 	self.scale = false;
		-- 	self.rateIcon:setScale(1, 1, 1);
		-- end

		-- 同一个选择返回是true或false
		self.rateIcon:setScale(1, -1, 1);
	else
		self.rateIcon:setScale(1, 1, 1);
	end
end

function Lua_MainCell:dispose()
	if self.banner ~= nil then
		self.banner:dispose();
		self.banner = nil;
	end
	if self.mainTxt ~= nil then
		self.mainTxt:dispose();
		self.mainTxt = nil;
	end

	self:superCall("dispose");
end










Lua_SubCell = class("Lua_SubCell", Lua_DragCustomBtnListCell);
function Lua_SubCell:ctor(p, btnType, cellWidth, cellHeight, offsetX, offsetY, skin)
	self:superCall("ctor", p, btnType, cellWidth, cellHeight, offsetX, offsetY, skin);

	-- print("Lua_SubCell", cellWidth, cellHeight, offsetX, offsetY);
end

function Lua_SubCell:buildShowItem()
	self:superCall("buildShowItem");

	self.banner = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_tips_001", 0, 0, 560, 100);

	self.subTxt = UICreate.createLabel(self.content, "", 0, 0, 500, 35, 30);
	self.subTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.subTxt.alignmentValue = 4;
end

function Lua_SubCell:updateData()
	self.subTxt.text = LanUtil.formateStr("这是subIndex为{1}的Lua_SubCell", self.data.subIdx);
end

function Lua_SubCell:onPressClick()
	self:superCall("onPressClick");

	print("subIdx", self.data.subIdx);
end

function Lua_SubCell:dispose()
	if self.banner ~= nil then
		self.banner:dispose();
		self.banner = nil;
	end
	if self.subTxt ~= nil then
		self.subTxt:dispose();
		self.subTxt = nil;
	end

	self:superCall("dispose");
end










Lua_CirculateTestItem = class("Lua_CirculateTestItem", Lua_CirculateItemClone)
function Lua_CirculateTestItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_CirculateTestItem:buildShowItem()
	self:superCall("buildShowItem")
	self.bg = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 150, 50)

	self.text = UICreate.createLabel(self.content, nil, 0, 0, 100, 35, 26)
	self.text.alignmentValue = 4
	self.text.horizontalOverflowValue = 1
end

function Lua_CirculateTestItem:setData(data)
	print(data)
	self.data = data
	if data % 2 == 1 then
		self.bg:setAltas("common_altas_1", "xui_common_button_006_n")
	else
		self.bg:setAltas("common_altas_1", "xui_common_button_007_n")
	end
	self.text.text = data
end

function Lua_CirculateTestItem:onPressClick()
	print(self.data)
end









Lua_RoundTestItem = class("Lua_RoundTestItem", Lua_RoundItem)
function Lua_RoundTestItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_RoundTestItem:buildShowItem()
	self:superCall("buildShowItem");

	self.bg = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0)

	self.text = UICreate.createLabel(self.content, nil, 0, 0, 100, 35, 26)
	self.text.alignmentValue = 4
	self.text.horizontalOverflowValue = 1
end

function Lua_RoundTestItem:setData(data)
	self.data = data
	if data % 2 == 1 then
		self.bg:setAltas("common_altas_1", "xui_common_button_004_n")
	else
		self.bg:setAltas("common_altas_1", "xui_common_button_005_n")
	end
	self.text.text = data
end

function Lua_RoundTestItem:onPressClick()
	print(self.data);
end







Lua_ScrollBoardTestItem = class("Lua_ScrollBoardTestItem", Lua_ScrollBoardCell)
function Lua_ScrollBoardTestItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ScrollBoardTestItem:buildShowItem()
	self:superCall("buildShowItem");
    
	self.bg = UICreate.createUIAtlasImage(self.content, "activities_atlas_1", "xui_zsdy_widget_3", 0, 0, 0, 0)
	self.text = UICreate.createLabel(self.content, nil, 0, 0, 35, 35, 26);
end

function Lua_ScrollBoardTestItem:setData(data)
	self:setEnable(data ~= nil);
	self.text.text = data;
	self.data = data;
end

function Lua_ScrollBoardTestItem:onPressClick()
	--print(self.data);
end