-- 特效演示面板
Lua_FightDebugEffectShowWindow = class("Lua_FightDebugEffectShowWindow", Lua_Window)
function Lua_FightDebugEffectShowWindow:ctor()
	self:superCall("ctor");

	self.w = 703;
	self.h = 1050;
	self.showTitle = true;
	self.titleText = "特效演示";
	self.titleNamePosY = 480
	self.windowName = "Lua_FightDebugEffectShowWindow";
	self.testFightId = 9876543210;
	self.showBlackMask = true;
	self.showWinBg = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";
	self.isClickClose = true;
end

function Lua_FightDebugEffectShowWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.actInfoStr = "";
	self.bPlayAct = false;
	self.bModelLoaded = false;
	self.model = UICreate.createModelEffImg(self.content, "", "", 0, 0, 0, 0);
	self.model:setCamField(1, 1, 100, true);
	self.model:setCamPos(0, 0, -10);
	-- self.model:setModelEffDir(90);
	-- self.model.canRot = true;
	self.model:SetDimensions(500, 500);
	self.model:setLocation(0, 280);
	self.model:addLuaLoadCompleteFun(self, self.onLoadedModel);
	self.model:addLuaAniAttackedFun(self, self.onAniAttacked);
	self.model:addLuaAniCompleteFun(self, self.onAniComplete);

    local txt = UICreate.createLabel(self.content, "特效ID: ", -110, -15, 200, 40, 26);
	txt.pivot = Lua_WindowUtil.getPivot(5);
	txt.alignmentValue = 5;
	txt.horizontalOverflowValue = 1;
	txt.colorStr = Lua_ColorDefine.transColor("846651");

    self.inputBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_edit_001", 0, -15, 200, 40);
    self.inputBg:addClickFuntion(self, self.onInputBgClick);

    self.inputLabel = UICreate.createLabel(self.content, "", 0, 5, 100, 40, 24);
    self.inputLabel.alignmentValue = 4;
    self.inputLabel.pivot = Lua_WindowUtil.getPivot(1);
    self.inputLabel.horizontalOverflowValue = 1;
    self.inputLabel.colorStr = Lua_ColorDefine.transColor("846651");

	self.testBtn = UICreate.createButton(self.content, "播放", 0, 0, 177, 58);
    self.testBtn:setLocation(0, -100, 0);
    self.testBtn:addClickFuntion(self, self.onBtnClick);

    self.actInfoTxt = UICreate.createLabel(self.content, "", 0, -275, 600, 250, 22);
    self.actInfoTxt.alignmentValue = 1;
    self.actInfoTxt.colorStr = Lua_ColorDefine.transColor("846651");

    self.clearBtn = UICreate.createButton(self.content, "清除", 0, 0, 177, 58);
    self.clearBtn:setLocation(-120, -450, 0);
    self.clearBtn:addClickFuntion(self, self.onClearBtnClick);

    self.copyBtn = UICreate.createButton(self.content, "拷贝", 0, 0, 177, 58);
    self.copyBtn:setLocation(120, -450, 0);
    self.copyBtn:addClickFuntion(self, self.onCopyBtnClick);

    self:addLuaEvent("FIGHTPLAY_STAGESET_SELECT", self, self.onSelectCellClick);
end

function Lua_FightDebugEffectShowWindow:onInputBgClick()
	Lua_WindowUtil.openWin("Lua_FightStageSetSelectWindow", Lua_WinParam.ACTION_OPEN, "effect");
end

function Lua_FightDebugEffectShowWindow:onSelectCellClick(data)
	if data ~= nil and data.configId ~= nil and data.configId ~= self.effId then
		self.effId = data.configId;
		local cfg = Lua_EffectConfigData.getConfigData(self.effId);
		if cfg ~= nil and cfg.url ~= nil and cfg.url ~= "" and cfg.modelName ~= nil and cfg.modelName ~= "" then
			if cfg.modelName ~= self.modelName then
				self.bModelLoaded = false;
				self.modelName = cfg.modelName;
				self.model:setUrl(cfg.url, cfg.modelName);
				self.inputLabel.text = cfg.name .. "("..cfg.configId..")";
				self.actInfoStr = self.actInfoStr .. cfg.name .. "("..cfg.configId..")\n";
				self.actInfoTxt.text = self.actInfoStr;
			end
		end
	end
end

function Lua_FightDebugEffectShowWindow:onClearBtnClick()
	self.actInfoStr = "";
	self.actInfoTxt.text = self.actInfoStr;
	OperateAlert.show("清除成功");
end

function Lua_FightDebugEffectShowWindow:onCopyBtnClick()
	LanUtil.copyToClipboard(self.actInfoStr);
	OperateAlert.show("拷贝成功");
end

function Lua_FightDebugEffectShowWindow:onBtnClick()
	if self.bModelLoaded ~= true then
		OperateAlert.show("模型加载中，请稍等");
		return;
	end

	if self.bPlayAct == true then
		if self.playActTime ~= nil and getTime() - self.playActTime > 10 then
			self.bPlayAct = false;
			self.playActTime = nil;
			self.actInfoStr = self.actInfoStr .. "超出10s，请确认是否有结束帧\n";
			self.actInfoTxt.text = self.actInfoStr;
		else
			OperateAlert.show("正在播放中，请稍等");
			return;
		end
	end

	self.attNum = 0;
	self.bPlayAct = true;
	self.playActTime = getTime();
	self.model:setModelEffEnable(false);
	self.model:setModelEffEnable(true);
end

function Lua_FightDebugEffectShowWindow:onLoadedModel()
	self.bModelLoaded = true;
	self.attNum = 0;
	self.bPlayAct = true;
	self.playActTime = getTime();
end

function Lua_FightDebugEffectShowWindow:onAniAttacked(act, actName)
	self.attNum = self.attNum + 1;
	local t = getTime() - self.playActTime;
	t = Mathf.Ceil(t * 30);
	self.actInfoStr = self.actInfoStr.."攻击帧"..self.attNum.."时间："..t.."\n";
	self.actInfoTxt.text = self.actInfoStr;
end

function Lua_FightDebugEffectShowWindow:onAniComplete(act, actName)
	local t = getTime() - self.playActTime;
	t = Mathf.Ceil(t * 30);
	self.actInfoStr = self.actInfoStr.."结束时间："..t.."\n";
	self.actInfoTxt.text = self.actInfoStr;

	self.bPlayAct = false;
	self.playActTime = nil;
	self.attNum = 0;
end

function Lua_FightDebugEffectShowWindow:dispose()
	
	self:superCall("dispose");
end