-- 战斗飘字展示界面
Lua_FightDebugFlyNumShowWindow = class("Lua_FightDebugFlyNumShowWindow", Lua_Window);
function Lua_FightDebugFlyNumShowWindow:ctor()
    self:superCall("ctor");
    
    self.windowName = "Lua_FightDebugFlyNumShowWindow";
    self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.testFightId = 9876543210;
end

function Lua_FightDebugFlyNumShowWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.backBtn:setLocation(100, 350, 0);

	self.hurtBtn = UICreate.createButton(self.content, "普伤", 0, 0, 177, 58);
	self.hurtBtn.anchor = Lua_WindowUtil.getAnchor(6);
	self.hurtBtn:setStyle(1);
	self.hurtBtn:setLocation(100, 425, 0);
	self.hurtBtn:addClickFuntion(self, self.onHurtBtnClick);

	self.critBtn = UICreate.createButton(self.content, "暴击", 0, 0, 177, 58);
	self.critBtn.anchor = Lua_WindowUtil.getAnchor(6);
	self.critBtn:setStyle(1);
	self.critBtn:setLocation(100, 490, 0);
	self.critBtn:addClickFuntion(self, self.onCritBtnClick);

	self.absorbBtn = UICreate.createButton(self.content, "吸收", 0, 0, 177, 58);
	self.absorbBtn.anchor = Lua_WindowUtil.getAnchor(6);
	self.absorbBtn:setStyle(1);
	self.absorbBtn:setLocation(100, 555, 0);
	self.absorbBtn:addClickFuntion(self, self.onAbsorbBtnClick);

	self.buffBtn = UICreate.createButton(self.content, "buff", 0, 0, 177, 58);
	self.buffBtn.anchor = Lua_WindowUtil.getAnchor(6);
	self.buffBtn:setStyle(1);
	self.buffBtn:setLocation(100, 620, 0);
	self.buffBtn:addClickFuntion(self, self.onBuffBtnClick);

	self.restraintBtn = UICreate.createButton(self.content, "克制", 0, 0, 177, 58);
	self.restraintBtn.anchor = Lua_WindowUtil.getAnchor(6);
	self.restraintBtn:setStyle(1);
	self.restraintBtn:setLocation(100, 685, 0);
	self.restraintBtn:addClickFuntion(self, self.onRestraintBtnClick);

	self.resistBtn = UICreate.createButton(self.content, "克制抵挡", 0, 0, 177, 58);
	self.resistBtn.anchor = Lua_WindowUtil.getAnchor(6);
	self.resistBtn:setStyle(1);
	self.resistBtn:setLocation(100, 750, 0);
	self.resistBtn:addClickFuntion(self, self.onResistBtnClick);

	self.huixueBtn = UICreate.createButton(self.content, "回血", 0, 0, 177, 58);
	self.huixueBtn.anchor = Lua_WindowUtil.getAnchor(6);
	self.huixueBtn:setStyle(1);
	self.huixueBtn:setLocation(100, 815, 0);
	self.huixueBtn:addClickFuntion(self, self.onHuixueBtnClick);

	self.skillBtn = UICreate.createButton(self.content, "被动技能", 0, 0, 177, 58);
	self.skillBtn.anchor = Lua_WindowUtil.getAnchor(6);
	self.skillBtn:setStyle(1);
	self.skillBtn:setLocation(100, 880, 0);
	self.skillBtn:addClickFuntion(self, self.onSkillBtnClick);

	self.stateBtn = UICreate.createButton(self.content, "闪避", 0, 0, 177, 58);
	self.stateBtn.anchor = Lua_WindowUtil.getAnchor(6);
	self.stateBtn:setStyle(1);
	self.stateBtn:setLocation(100, 945, 0);
	self.stateBtn:addClickFuntion(self, self.onStateBtnClick);
end

function Lua_FightDebugFlyNumShowWindow:getThing()
	local arr = DataCenter.thingData:getThingIds(Scene3DManager.instance.curShowSceneId, self.testFightId);
    if arr ~= nil and arr:getSize() > 0 then
    	return DataCenter.thingData:getThingPlayer(Scene3DManager.instance.curShowSceneId, self.testFightId, arr[1]);
    end
    return nil;
end

function Lua_FightDebugFlyNumShowWindow:onHurtBtnClick(go)
	local thing = self:getThing();
	if thing ~= nil then
		thing.player:showStateText(Mathf.Random(1, 9999999), nil, nil, nil, 0, 1);
	end
end

function Lua_FightDebugFlyNumShowWindow:onCritBtnClick(go)
	local thing = self:getThing();
	if thing ~= nil then
		thing.player:showStateText(Mathf.Random(1, 9999999), nil, nil, nil, 0, 5);
	end
end

function Lua_FightDebugFlyNumShowWindow:onAbsorbBtnClick(go)
	local thing = self:getThing();
	if thing ~= nil then
		thing.player:showStateText(Mathf.Random(1, 9999999), nil, nil, nil, 5, 1);
	end
end

function Lua_FightDebugFlyNumShowWindow:onBuffBtnClick(go)
	local thing = self:getThing();
	if thing ~= nil then
		thing.player:showBuffText(1009001);
	end
end

function Lua_FightDebugFlyNumShowWindow:onRestraintBtnClick(go)
	local thing = self:getThing();
	if thing ~= nil then
		thing.player:showStateText(Mathf.Random(1, 9999999), nil, nil, nil, 4, 1);
	end
end

function Lua_FightDebugFlyNumShowWindow:onResistBtnClick(go)
	local thing = self:getThing();
	if thing ~= nil then
		thing.player:showStateText(Mathf.Random(1, 9999999), nil, nil, nil, 6, 1);
	end
end

function Lua_FightDebugFlyNumShowWindow:onHuixueBtnClick(go)
	local thing = self:getThing();
	if thing ~= nil then
		thing.player:showStateText(Mathf.Random(1, 9999999), nil, nil, nil, 0, 4);
	end
end

function Lua_FightDebugFlyNumShowWindow:onSkillBtnClick(go)
	local thing = self:getThing();
	if thing ~= nil then
		thing.player:showStateText(0, "被动技能", nil, nil, 0, 3);
	end
end

function Lua_FightDebugFlyNumShowWindow:onStateBtnClick(go)
	local thing = self:getThing();
	if thing ~= nil then
		thing.player:showStateText(0, nil, "number", "xui_sb_word_0", 0, 6);
	end
end

function Lua_FightDebugFlyNumShowWindow:dispose()
	self:superCall("dispose");
end