checkRequire("Lua_FightStageHeroPorpItem");
Lua_FightDebugHeroSelectWindow = class("Lua_FightDebugHeroSelectWindow", Lua_Window)
function Lua_FightDebugHeroSelectWindow:ctor()
	self:superCall("ctor");

	self.w = 703;
	self.h = 400;
	self.showTitle = true;
	self.titleText = "英雄选择";
	self.titleNamePosY = 150
	self.windowName = "Lua_FightDebugHeroSelectWindow";
	self.showBlackMask = true;
	self.showWinBg = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";
	self.showBlackMask = true;
	self.showWinBg = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";
	self.isClickClose = true;
end

function Lua_FightDebugHeroSelectWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.heroCell = Lua_FightStageHeroPorpItem.new(self.content);
	self.heroCell.propName = "hero_id";
	self.heroCell:setNameTxt("英雄");
	self.heroCell:setLocation(30, 60, 0);

	self.posCell = Lua_FightStageHeroPorpItem.new(self.content);
	self.posCell.propName = "position";
	self.posCell:setNameTxt("站位");
	self.posCell:setValue(1);
	self.posCell:setLocation(30, 0, 0);

	self.campCell = Lua_FightStageHeroPorpItem.new(self.content);
	self.campCell.propName = "campId";
	self.campCell:setNameTxt("阵型");
	self.campCell:setValue(1);
	self.campCell:setLocation(30, -60, 0);

	local btn = UICreate.createButton(self.content, "添加", 10, -130, 177, 58);
	btn:addClickFuntion(self, self.onFightDebugAddHero);
end

function Lua_FightDebugHeroSelectWindow:onFightDebugAddHero(go)
	local position = tonumber(self.posCell.value);
	if position == nil or position <= 0 or position > 11 then
		OperateAlert.show("站位不在1-11合理区间");
		return;
	end

	local campId = tonumber(self.campCell.value);
	if campId == nil or Lua_FightCampPosConfig.getConfigData(campId) == nil then
		OperateAlert.show("无对应阵型id");
		return;
	end

	local heroId = tonumber(self.heroCell.value);
	Lua_MsgUtil.callFunc("fightdebug_update_addthings", {side = self.side, heroId = heroId, position = position, campId = campId});
end

function Lua_FightDebugHeroSelectWindow:showWin(data)
    self:superCall("showWin", data);
    self.side = data;
end

function Lua_FightDebugHeroSelectWindow:dispose()
	
	self:superCall("dispose");
end