checkRequire("Lua_FightHpBar");
checkRequire("Lua_FightShieldBar");
Lua_FightDebugHpWindow = class("Lua_FightDebugHpWindow", Lua_Window)
function Lua_FightDebugHpWindow:ctor()
	self:superCall("ctor");

	self.w = 608;
	self.h = 300;
	self.windowName = "Lua_FightDebugHpWindow";
	self.skinName = "FightDebugHpWindow_skin";
end

function Lua_FightDebugHpWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.hpBar = Lua_FightHpBar.new(self.content, "fight_atlas_1", "ui_zd_progress_001_b", "ui_zd_progress_001_f", 97, 13);
	self.hpBar:setLocation(-85, -170, 0);
	self.hpBar:setBarOffset(6, 6);
	self.hpBar:createSecondBar("fight_atlas_1", "ui_zd_progress_003_f"); -- 加血
	self.hpBar:createAnimationBar("fight_atlas_1", "ui_zd_progress_004_f"); -- 扣血
	self.hpBar:setEnable(false);

	self.shieldBar = Lua_FightShieldBar.new(self.content, "fight_atlas_1", nil, "ui_zd_progress_001_f", 97, 13);
	self.shieldBar:setLocation(-85, -170, 0);
	self.shieldBar:setEnable(false);

	self.ani_intervalInput.text = Lua_CommonUtil.getCommonConfig("bar_ani_interval", 4, 0.2);
	self.ani_waitInput.text = Lua_CommonUtil.getCommonConfig("bar_ani_wait", 4, 0.2);
	self.ani_time1Input.text = Lua_CommonUtil.getCommonConfig("bar_ani_time1", 4, 0.25);
	self.ani_time2Input.text = Lua_CommonUtil.getCommonConfig("bar_ani_time2", 4, 0.25);
	self.maxInput.text = 10000;
	self.plusInput.text = 1000;
	self.lessInput.text = 1000;

	self.btnHp:addClickFuntion(self, self.onBtnHpClick);
	self.btnShield:addClickFuntion(self, self.onBtnShieldClick);
	self.btnLess:addClickFuntion(self, self.onBtnLessClick);
	self.btnPlus:addClickFuntion(self, self.onBtnPlusClick);

	self.btnLess:setEnable(false);
	self.btnPlus:setEnable(false);
end

function Lua_FightDebugHpWindow:dispose()
	if self.hpBar ~= nil then
		self.hpBar:dispose();
		self.hpBar = nil;
	end
	if self.shieldBar ~= nil then
		self.shieldBar:dispose();
		self.shieldBar = nil;
	end
	self:superCall("dispose");
end

function Lua_FightDebugHpWindow:onBtnHpClick(go)
	if self.maxInput.text == "" or self.plusInput.text == "" or self.lessInput.text == "" or self.ani_intervalInput.text == "" or self.ani_waitInput.text == "" or self.ani_time1Input.text == "" or self.ani_time2Input.text == "" then
		OperateAlert.show("填错了");
		return;
	end

	self.btnLess:setEnable(true);
	self.btnPlus:setEnable(true);

	self.showHp = true;
	self.shieldBar:setEnable(not self.showHp);
	self.hpBar:setEnable(self.showHp);

	self.hpBar:endTimer();
	self.hpBar:init();
	self.hpBar.aniInterval = tonumber(self.ani_intervalInput.text);
	self.hpBar.aniWait = tonumber(self.ani_waitInput.text);
	self.hpBar.animation_time_1 = tonumber(self.ani_time1Input.text);
	self.hpBar.animation_time_2 = tonumber(self.ani_time2Input.text);
	
	self.maxValue = tonumber(self.maxInput.text);
	self.showValue = self.maxValue;
	self.hpBar:setMaxValue(self.maxValue);
	self.hpBar:setValue(self.showValue);
end

function Lua_FightDebugHpWindow:onBtnShieldClick(go)
	if self.maxInput.text == "" or self.plusInput.text == "" or self.lessInput.text == "" or self.ani_intervalInput.text == "" or self.ani_waitInput.text == "" or self.ani_time1Input.text == "" or self.ani_time2Input.text == "" then
		OperateAlert.show("填错了");
		return;
	end

	self.btnLess:setEnable(true);
	self.btnPlus:setEnable(true);

	self.showHp = false;
	self.shieldBar:setEnable(not self.showHp);
	self.hpBar:setEnable(self.showHp);

	self.shieldBar:endTimer();
	self.shieldBar:init();
	self.shieldBar.aniInterval = tonumber(self.ani_intervalInput.text);
	self.shieldBar.animation_time = tonumber(self.ani_time1Input.text);
	
	self.maxValue = tonumber(self.maxInput.text);
	self.showValue = self.maxValue;
	self.shieldBar:setMaxValue(self.maxValue);
	self.shieldBar:setValue(self.showValue);
end

function Lua_FightDebugHpWindow:onBtnLessClick(go)
	self.showValue = self.showValue - tonumber(self.lessInput.text);
	if self.showValue < 0 then
		self.showValue = 0;
	end
	if self.showHp then
		self.hpBar:setValue(self.showValue);
	else
		self.shieldBar:setValue(self.showValue);
	end
end

function Lua_FightDebugHpWindow:onBtnPlusClick(go)
	self.showValue = self.showValue + tonumber(self.plusInput.text);
	if self.showValue > self.maxValue then
		self.showValue = self.maxValue;
	end
	if self.showHp then
		self.hpBar:setValue(self.showValue);
	else
		self.shieldBar:setValue(self.showValue);
	end
end