-- 模型动作演示
checkRequire("Lua_FightStageHeroPorpItem");
Lua_FightDebugModelShowWindow = class("Lua_FightDebugModelShowWindow", Lua_Window)
function Lua_FightDebugModelShowWindow:ctor()
	self:superCall("ctor");

	self.w = 703;
	self.h = 1200;
	self.showTitle = true;
	self.titleText = "模型动作演示";
	self.titleNamePosY = 554
	self.windowName = "Lua_FightDebugModelShowWindow";
	self.testFightId = 9876543210;
	self.showBlackMask = true;
	self.showWinBg = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";
	self.isClickClose = true;
end

function Lua_FightDebugModelShowWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.actInfoStr = "";
	self.bPlayAct = false;
	self.bModelLoaded = false;
	self.model = UICreate.createModelEffImg(self.content, nil, nil, 0, 0, 0, 0);
	self.model:setCamField(2, 1, 100, true);
	self.model:setCamPos(0, 1, -10);
	self.model:setModelEffDir(90);
	self.model.canRot = true;
	self.model:SetDimensions(720, 720);
	self.model:setLocation(0, 300);
	self.model:addLuaLoadCompleteFun(self, self.onLoadedModel);
	self.model:addLuaAniAttackedFun(self, self.onAniAttacked);
	self.model:addLuaAniCompleteFun(self, self.onAniComplete);
	self.model:setAction(0);

	self.cbHero = UICreate.createCheckBox(self.content, "英雄", -100, -40, 0, 0)
	self.cbHero.selected = true
	self.cbHero:addBoxChange(self, self.onHero)

	self.cbArtifact = UICreate.createCheckBox(self.content, "浣熊", 100, -40, 0, 0)
	self.cbArtifact:addBoxChange(self, self.onArtifact)

	self.heroCell = Lua_FightStageHeroPorpItem.new(self.content);
	self.heroCell.propName = "hero_id";
	self.heroCell:setNameTxt("英雄");
	self.heroCell:setLocation(0, -90, 0);

	local txt = UICreate.createLabel(self.content, "动作ID: ", -110, -150, 200, 40, 26);
	txt.pivot = Lua_WindowUtil.getPivot(5);
	txt.alignmentValue = 5;
	txt.horizontalOverflowValue = 1;
	txt.colorStr = Lua_ColorDefine.transColor("846651");

    self.inputBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_edit_001", 0, -150, 400, 40);

    self.inputLabel = UICreate.createInput(self.content, "", 0, -150, 200, 40, 24);
    self.inputLabel.alignmentValue = 3;
    self.inputLabel.contentTypeValue = 2;
    self.inputLabel.colorStr = Lua_ColorDefine.transColor("846651");

	self.testBtn = UICreate.createButton(self.content, "播放", 0, -230, 177, 58);
    self.testBtn:addClickFuntion(self, self.onBtnClick);

    self.actInfoTxt = UICreate.createLabel(self.content, "", 0, -390, 600, 250, 22);
    self.actInfoTxt.alignmentValue = 1;
    self.actInfoTxt.colorStr = Lua_ColorDefine.transColor("846651");

    self.clearBtn = UICreate.createButton(self.content, "清除", 0, 0, 177, 58);
    self.clearBtn:setLocation(-120, -520, 0);
    self.clearBtn:addClickFuntion(self, self.onClearBtnClick);

    self.copyBtn = UICreate.createButton(self.content, "拷贝", 0, 0, 177, 58);
    self.copyBtn:setLocation(120, -520, 0);
    self.copyBtn:addClickFuntion(self, self.onCopyBtnClick);

	Lua_MsgUtil.addEventListener("FIGHTPLAY_STAGESET_SELECT", self, self.onSelectCellClick);
end

function Lua_FightDebugModelShowWindow:onHero(state)
	self.cbArtifact.selected = false
	self.heroCell.propName = "hero_id";
	self.heroCell:setNameTxt("英雄");
end

function Lua_FightDebugModelShowWindow:onArtifact(state)
	self.cbHero.selected = false
	self.heroCell.propName = "artifact_id";
	self.heroCell:setNameTxt("浣熊");
end

function Lua_FightDebugModelShowWindow:onSelectCellClick(data)
	print("onSelectCellClick")
	if data ~= nil then
		if self.cbHero.selected then -- 英雄
			if data.id ~= self.selectedId then
				self.selectedId = data.id;
				local cfg = Lua_HeroConfigData.getConfig(data.id);
				if cfg ~= nil and cfg.modelSrc ~= nil and cfg.jid ~= nil then
					self.bModelLoaded = false;
					self.model:setUrl(cfg.floder..cfg.jid, cfg.modelSrc);
					self.model:setAction(0);
					self.model:setScale(1, 1, 1)
					self.actInfoStr = self.actInfoStr .. cfg.name .. "("..cfg.id..")\n";
					-- print(self.actInfoStr);
					self.actInfoTxt.text = self.actInfoStr;
				end
			end
		elseif data.id ~= nil then -- 浣熊
			if data.id ~= self.selectedId then
				self.selectedId = data.id;
				local cfg = getConfig("artifact", data.id)
				if cfg ~= nil and cfg.modelSrc ~= nil and cfg.jid ~= nil then
					self.bModelLoaded = false;
					self.model:setUrl("/model/role/"..cfg.jid, cfg.modelSrc);
					self.model:setAction(0);
					self.model:setScale(0.5, 0.5, 0.5)
					self.actInfoStr = self.actInfoStr .. cfg.name .. "("..cfg.id..")\n";
					self.actInfoTxt.text = self.actInfoStr;
				end
			end
		end
	end
end

function Lua_FightDebugModelShowWindow:onClearBtnClick()
	self.actInfoStr = "";
	self.actInfoTxt.text = self.actInfoStr;
	OperateAlert.show("清除成功");
end

function Lua_FightDebugModelShowWindow:onCopyBtnClick()
	LanUtil.copyToClipboard(self.actInfoStr);
	OperateAlert.show("拷贝成功");
end

function Lua_FightDebugModelShowWindow:onBtnClick()
	if self.bModelLoaded ~= true then
		OperateAlert.show("模型加载中，请稍等");
		return;
	end

	if self.bPlayAct == true then
		if self.playActTime ~= nil and getTime() - self.playActTime > 10 then
			self.bPlayAct = false;
			self.playActTime = nil;
			self.playAct = 0;
			self.actInfoStr = self.actInfoStr .. "超出10s，请确认是否有结束帧\n";
			-- print(self.actInfoStr);
			self.actInfoTxt.text = self.actInfoStr;
		else
			OperateAlert.show("正在播放动作中，请稍等");
			return;
		end
	end

	local str = self.inputLabel.text;
	if str ~= nil and str ~= "" then
		local num = tonumber(str);
		if num ~= nil then
			self.attNum = 0;
			self.bPlayAct = true;
			self.playAct = num;
			self.model:setAction(num);
			self.playActTime = getTime();
			self.actInfoStr = self.actInfoStr.."动作ID：" .. num .. "\n";
			-- print(self.actInfoStr);
			self.actInfoTxt.text = self.actInfoStr;
		end
	end
end

function Lua_FightDebugModelShowWindow:onLoadedModel()
	self.bModelLoaded = true;
	print("onLoadedModel")
end

function Lua_FightDebugModelShowWindow:onAniAttacked(act, actName)
	if self.playAct == nil or self.playAct == 0 then
		return;
	end

	self.attNum = self.attNum + 1;
	local t = getTime() - self.playActTime;
	t = Mathf.Ceil(t * 30);
	self.actInfoStr = self.actInfoStr.."攻击帧"..self.attNum.."时间："..t.."\n";
	-- print(self.actInfoStr);
	self.actInfoTxt.text = self.actInfoStr;
end

function Lua_FightDebugModelShowWindow:onAniComplete(act, actName)
	if self.playAct == nil or self.playAct == 0 then
		return;
	end

	local t = getTime() - self.playActTime;
	t = Mathf.Ceil(t * 30);
	self.actInfoStr = self.actInfoStr.."结束时间："..t.."\n";
	-- print(self.actInfoStr);
	self.actInfoTxt.text = self.actInfoStr;

	self.bPlayAct = false;
	self.playActTime = nil;
	self.playAct = 0;
	self.attNum = 0;
end

function Lua_FightDebugModelShowWindow:dispose()
	
	self:superCall("dispose");
end