-- 战斗调试窗口
Lua_FightDebugSelectThingWindow = class("Lua_FightDebugSelectThingWindow", Lua_Window)
function Lua_FightDebugSelectThingWindow:ctor()
	self:superCall("ctor");

	self.w = 703;
	self.h = 800;
	self.showTitle = true;
	self.titleText = "单位选择";
	self.windowName = "Lua_FightDebugSelectThingWindow";
	self.showBlackMask = true;
	self.showWinBg = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";
	self.isClickClose = true;
	self.testFightId = 9876543210;
end

function Lua_FightDebugSelectThingWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 600, 670, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_FightDebugSelectThingItem, 600, 40, 1);
    self.dragList:setLocation(0, -25, 0);

    local arr = DataCenter.thingData:getThingIds(Scene3DManager.instance.curShowSceneId, self.testFightId);
    self.dragList:setArrayData(arr);
end

function Lua_FightDebugSelectThingWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	Lua_MsgUtil.callFunc("FightDebug_Select_Thing", nil);
	self:superCall("dispose");
end













Lua_FightDebugSelectThingItem = class("Lua_FightDebugSelectThingItem", Lua_ListCell);
function Lua_FightDebugSelectThingItem:ctor(p)
    self:superCall("ctor", p, nil);
    self.testFightId = 9876543210;
end

function Lua_FightDebugSelectThingItem:buildShowItem()
    self:superCall("buildShowItem");

	self.txt = UICreate.createLabel(self.content, "", 0, 0, 0, 40, 26);
    self.txt.horizontalOverflowValue = 1
    self.txt.colorStr = Lua_ColorDefine.transColor("846651");
end

function Lua_FightDebugSelectThingItem:dispose()
    self:superCall("dispose");

end

function Lua_FightDebugSelectThingItem:setData(data)
    self.data = data;
    if data == nil then
        return;
    end

    local thing = DataCenter.thingData:getThingPlayer(Scene3DManager.instance.curShowSceneId, self.testFightId, self.data);
    if thing ~= nil then
    	local str = thing.formationType == Lua_FightDefine.FIGHT_ATTACKER and "攻击者: " or "防守者: ";
    	local objId = thing.objId;
    	local cfg = Lua_HeroConfigData.getConfig(objId);
		if cfg ~= nil then
			self.txt.text = str .. cfg.name .. "("..data.." , "..objId.." ，位置"..thing.formationPos..")";
		else
			self.txt.text = str .. tostring(data);
		end
    else
    	self.txt.text = tostring(data);
    end
end

function Lua_FightDebugSelectThingItem:onPressClick()
	Lua_MsgUtil.callFunc("FightDebug_Select_Thing", self.data);
	Lua_WindowUtil.openWin("Lua_FightDebugSelectThingWindow", Lua_WinParam.ACTION_CLOSE); 
end