-- 技能效果设置界面
checkRequire("Lua_EffectConfigData");
checkRequire("Lua_BuffConfigData");
checkRequire("Lua_SkillEffectConfigData");
checkRequire("Lua_SkillConfigData");
Lua_FightDebugSkillSetWindow = class("Lua_FightDebugSkillSetWindow", Lua_Window)
function Lua_FightDebugSkillSetWindow:ctor()
	self:superCall("ctor");

	self.isClickClose = false;
	self.showWinBg = false;
	self.showClose = false;
	self.showTitleBg = false;
	self.showTitle = false;
	self.titleText = nil;
	self.showBackBtn = false;
	self.windowName = "Lua_FightDebugSkillSetWindow";
	self.skinName = "FightDebugSkillSetWindow_skin";
	self.testFightId = 9876543210;
end

function Lua_FightDebugSkillSetWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.configPath = DataCenter.fightData.testConfigPath;
	if self.configPath ~= nil then
		self.refreshTxt.text = self.configPath;
	end

	self.targetsDic = {};
	self:initAttackInfo();
	self.refreshBg.clickScale = false;
	self.closeImg:addClickFuntion(self, self.onBtnCloseClick);
	self.refreshBtn:addClickFuntion(self, self.onRefreshBtnClick);
	self.refreshBg:addClickFuntion(self, self.onRefreshBgClick);
	self.targetBg1:addClickFuntion(self, self.onTargetBg1Click);
	self.targetBg2:addClickFuntion(self, self.onTargetBg2Click);
	self.targetBg3:addClickFuntion(self, self.onTargetBg3Click);
	self.targetBg4:addClickFuntion(self, self.onTargetBg4Click);
	self.targetBg5:addClickFuntion(self, self.onTargetBg5Click);
	self.targetBg6:addClickFuntion(self, self.onTargetBg6Click);
	self.targetBg7:addClickFuntion(self, self.onTargetBg7Click);
	self.targetBg8:addClickFuntion(self, self.onTargetBg8Click);
	self.targetBg9:addClickFuntion(self, self.onTargetBg9Click);
	self.attackbg:addClickFuntion(self, self.onAttackbgClick);
	self.skillBg:addClickFuntion(self, self.onSkillBgClick);
	self:addLuaEvent("FIGHTPLAY_STAGESET_SELECT", self, self.onSelectCellClick);
	self:addLuaEvent("FightDebug_Select_Thing", self, self.onSelectThing);
end

function Lua_FightDebugSkillSetWindow:onRefreshBtnClick(go)
	if self.configPath == nil or self.configPath == "" then
		return;
	end

	LuaUtil.refreshConfigs(self.configPath);
end

function Lua_FightDebugSkillSetWindow:onRefreshBgClick(go)
	local str = LuaUtil.selectPath();
	if str ~= nil and str ~= "" then
		self.configPath = str;
		self.refreshTxt.text = self.configPath;
		DataCenter.fightData.testConfigPath = str;

		Lua_BuffConfigData.configsDic = nil;
		Lua_EffectConfigData.configsDic = nil;
		Lua_EffectConfigData.configArr = nil;
		Lua_SkillEffectConfigData.configsDic = nil;
		Lua_SkillConfigData.configArr = nil;
		Lua_SkillConfigData.configsDic = nil;
	end
end

function Lua_FightDebugSkillSetWindow:onTargetBg1Click(go)
	self.openTag = "targetBg1";
	Lua_WindowUtil.openWin("Lua_FightDebugSelectThingWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugSkillSetWindow:onTargetBg2Click(go)
	self.openTag = "targetBg2";
	Lua_WindowUtil.openWin("Lua_FightDebugSelectThingWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugSkillSetWindow:onTargetBg3Click(go)
	self.openTag = "targetBg3";
	Lua_WindowUtil.openWin("Lua_FightDebugSelectThingWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugSkillSetWindow:onTargetBg4Click(go)
	self.openTag = "targetBg4";
	Lua_WindowUtil.openWin("Lua_FightDebugSelectThingWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugSkillSetWindow:onTargetBg5Click(go)
	self.openTag = "targetBg5";
	Lua_WindowUtil.openWin("Lua_FightDebugSelectThingWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugSkillSetWindow:onTargetBg6Click(go)
	self.openTag = "targetBg6";
	Lua_WindowUtil.openWin("Lua_FightDebugSelectThingWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugSkillSetWindow:onTargetBg7Click(go)
	self.openTag = "targetBg7";
	Lua_WindowUtil.openWin("Lua_FightDebugSelectThingWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugSkillSetWindow:onTargetBg8Click(go)
	self.openTag = "targetBg8";
	Lua_WindowUtil.openWin("Lua_FightDebugSelectThingWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugSkillSetWindow:onTargetBg9Click(go)
	self.openTag = "targetBg9";
	Lua_WindowUtil.openWin("Lua_FightDebugSelectThingWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugSkillSetWindow:onAttackbgClick(go)
	self.openTag = "attackBg";
	Lua_WindowUtil.openWin("Lua_FightDebugSelectThingWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugSkillSetWindow:onSkillBgClick(go)
	Lua_WindowUtil.openWin("Lua_FightStageSetSelectWindow", Lua_WinParam.ACTION_AUTO, "skill");
end

function Lua_FightDebugSkillSetWindow:onSelectCellClick(data)
	if data ~= nil then
		self.skillId = data.skillId;
        self.skillTxt.text = data.name .. "(" .. data.skillId .. ")";
	end
end

function Lua_FightDebugSkillSetWindow:onSelectThing(data)
	if data ~= nil then
		local str = tostring(data);
		local thing = DataCenter.thingData:getThingPlayer(Scene3DManager.instance.curShowSceneId, self.testFightId, data);
	    if thing ~= nil then
	    	str = thing.formationType == Lua_FightDefine.FIGHT_ATTACKER and "攻击者: " or "防守者: ";
	    	local objId = thing.objId;
	    	local cfg = Lua_HeroConfigData.getConfig(objId);
			if cfg ~= nil then
				str = str .. cfg.name .. "("..data.."，位置"..thing.formationPos..")";
			else
				str = str .. tostring(data);
			end
	    end

    	local arr = DataCenter.fightData.testTargetsArr;
	 --    if self.openTag ~= "attackBg" then
		--     for k, v in ipairs(self.targetsDic) do
		--     	if v == data then
		--     		arr:removeItem(v);
		--     		self.targetsDic[k] = nil;
		--     		self["targetTxt"..k].text = "";
		--     		break;
		--     	end
		--     end
		-- end

		if self.openTag == "targetBg1" then
			self.targetTxt1.text = str;
			self.targetsDic[1] = data;
			arr:add(data);
		elseif self.openTag == "targetBg2" then
			self.targetTxt2.text = str;
			self.targetsDic[2] = data;
			arr:add(data);
		elseif self.openTag == "targetBg3" then
			self.targetTxt3.text = str;
			self.targetsDic[3] = data;
			arr:add(data);
		elseif self.openTag == "targetBg4" then
			self.targetTxt4.text = str;
			self.targetsDic[4] = data;
			arr:add(data);
		elseif self.openTag == "targetBg5" then
			self.targetTxt5.text = str;
			self.targetsDic[5] = data;
			arr:add(data);
		elseif self.openTag == "targetBg6" then
			self.targetTxt6.text = str;
			self.targetsDic[6] = data;
			arr:add(data);
		elseif self.openTag == "targetBg7" then
			self.targetTxt7.text = str;
			self.targetsDic[7] = data;
			arr:add(data);
		elseif self.openTag == "targetBg8" then
			self.targetTxt8.text = str;
			self.targetsDic[8] = data;
			arr:add(data);
		elseif self.openTag == "targetBg9" then
			self.targetTxt9.text = str;
			self.targetsDic[9] = data;
			arr:add(data);
		elseif self.openTag == "attackBg" then
			self.attackTxt.text = str;
			self.attackerId = data;
		end
	end
	self.openTag = nil;
end

function Lua_FightDebugSkillSetWindow:initAttackInfo()
	local avo = DataCenter.fightData.testAttackVo;
	if avo == nil then
		return;
	end

	self.skillId = avo.skillId;
	if self.skillId ~= nil and self.skillId > 0 then
		local cfg = Lua_SkillConfigData.getConfigData(self.skillId);
        self.skillTxt.text = cfg.name .. "(" .. self.skillId .. ")";
    end

    self.attackerId = tonumber(tostring(avo.attackerId));
    if self.attackerId ~= nil and self.attackerId > 0 then
    	local str = tostring(self.attackerId);
		local thing = DataCenter.thingData:getThingPlayer(Scene3DManager.instance.curShowSceneId, self.testFightId, self.attackerId);
	    if thing ~= nil then
	    	str = thing.formationType == Lua_FightDefine.FIGHT_ATTACKER and "攻击者: " or "防守者: ";
	    	local objId = thing.objId;
	    	local cfg = Lua_HeroConfigData.getConfig(objId);
			if cfg ~= nil then
				str = str .. cfg.name .. "("..self.attackerId.."，位置"..thing.formationPos..")";
			else
				str = str .. tostring(self.attackerId);
			end
	    end
	    self.attackTxt.text = str;
    end

    local arr = DataCenter.fightData.testTargetsArr;
    local targetCount = arr:getSize();
    if targetCount > 0 then
    	for i = 1, targetCount do
    		local rid = arr[i];
			-- rid = tonumber(tostring(rid));
    		if rid ~= nil and rid > 0 then
	    		local str = tostring(rid);
				local thing = DataCenter.thingData:getThingPlayer(Scene3DManager.instance.curShowSceneId, self.testFightId, rid);
			    if thing ~= nil then
			    	str = thing.formationType == Lua_FightDefine.FIGHT_ATTACKER and "攻击者: " or "防守者: ";
			    	local objId = thing.objId;
			    	local cfg = Lua_HeroConfigData.getConfig(objId);
					if cfg ~= nil then
						str = str .. cfg.name .. "("..rid.."，位置"..thing.formationPos..")";
					else
						str = str .. tostring(rid);
					end
			    end
			    self.targetsDic[i] = rid;
			    self["targetTxt"..i].text = str;
			end
    	end
    end
end

function Lua_FightDebugSkillSetWindow:dispose()
	if self.skillId ~= nil and self.skillId > 0 and self.attackerId ~= nil and self.attackerId > 0 then
		local avo = DataCenter.fightData.testAttackVo;
		if avo == nil then
			avo = AttackVO(Scene3DManager.instance.curShowSceneId, self.testFightId);
	        DataCenter.fightData.testAttackVo = avo;
		end
		avo.skillId = self.skillId;
		avo.attackerId = self.attackerId;

		local arr = DataCenter.fightData.testTargetsArr;
		arr:clear();
		if self.targetsDic ~= nil then
			for k, v in ipairs(self.targetsDic) do
		    	if v ~= nil and v > 0 then
		    		arr:add(v);
		    	end
		    end
		end
	end
	
	self:superCall("dispose");
end