-- 战斗调试窗口
checkRequire("Lua_FightTemplateConfigData");
Lua_FightDebugWindow = class("Lua_FightDebugWindow", Lua_Window)
function Lua_FightDebugWindow:ctor()
	self:superCall("ctor");

	local arr = Lua_FightTemplateConfigData.getTestTempConfig();
	if arr ~= nil then
		self.h = 720 + Mathf.Ceil((arr:getSize() + 2) / 3) * 80;
	else
		self.h = 800;
	end
	self.w = 703;
	self.windowName = "Lua_FightDebugWindow";
	self.showBlackMask = false;
	self.showWinBg = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_007";
	self.showClose = true;
	self.showTitle = true;
	self.titleText = "战斗调试";
	self.titleNamePosY = self.h / 2 - 48;
	self.btnClosePosX = 296;
	self.btnClosePosY = self.h / 2 - 48;
end

function Lua_FightDebugWindow:buildShowItem()
	self:superCall("buildShowItem");
	LuaUtil.setRectSize(self.rectTf, self.w, self.h);

	local dx = 0;
	local dy = 0;
	local step = 0;
	local arr = Lua_FightTemplateConfigData.getTestTempConfig();
	if arr ~= nil and arr:getSize() > 0 then
		for i = 1, arr:getSize() do
			step = step + 1;
			dx = -400 + 200 * ((step % 3) > 0 and (step % 3) or 3);
			dy = -55 - Mathf.Ceil(step / 3) * 60;
			local btn = UICreate.createButton(self.content, arr[i].title, dx, dy, 180, 54);
			btn:setStyle(14);
			btn.txt:setLocation(0, 0, 0);
			btn.txt.fontSize = 28;
			btn:addClickFuntion(self, self.onFightTest);
			btn.anchor = Lua_WindowUtil.getAnchor(1);
			btn.name = arr[i].id;
		end
	else
		step = step + 1;
		dx = -400 + 200 * ((step % 3) > 0 and (step % 3) or 3);
		dy = -55 - Mathf.Ceil(step / 3) * 60;
		local btn = UICreate.createButton(self.content, "快速战斗", dx, dy, 180, 54);
		btn:setStyle(14);
		btn.txt:setLocation(0, 0, 0);
		btn.txt.fontSize = 28;
		btn:addClickFuntion(self, self.onFightTest);
		btn.anchor = Lua_WindowUtil.getAnchor(1);
		btn.name = "9999";
	end

	step = step + 1;
	dx = -400 + 200 * ((step % 3) > 0 and (step % 3) or 3);
	dy = -55 - Mathf.Ceil(step / 3) * 60;
	btn = UICreate.createButton(self.content, "战斗自定义", dx, dy, 180, 54);
	btn:setStyle(14);
	btn.txt:setLocation(0, 0, 0);
	btn.txt.fontSize = 28;
	btn:addClickFuntion(self, self.onFightDebugTest);
	btn.anchor = Lua_WindowUtil.getAnchor(1);

	step = step + 1;
	dx = -400 + 200 * ((step % 3) > 0 and (step % 3) or 3);
	dy = -55 - Mathf.Ceil(step / 3) * 60;
	btn = UICreate.createButton(self.content, "技能模板", dx, dy, 180, 54);
	btn:setStyle(14);
	btn.txt:setLocation(0, 0, 0);
	btn.txt.fontSize = 28;
	btn:addClickFuntion(self, self.onSkillDebugTest);
	btn.anchor = Lua_WindowUtil.getAnchor(1);

	step = step + 1;
	dx = -400 + 200 * ((step % 3) > 0 and (step % 3) or 3);
	dy = -55 - Mathf.Ceil(step / 3) * 60;
	if DataCenter.fightData.bSaveFightData then
		self.btnSaveData = UICreate.createButton(self.content, "保存数据-关", dx, dy, 180, 54);
	else
		self.btnSaveData = UICreate.createButton(self.content, "保存数据-开", dx, dy, 180, 54);
	end
	self.btnSaveData:setStyle(14);
	self.btnSaveData.txt:setLocation(0, 0, 0);
	self.btnSaveData.txt.fontSize = 28;
	self.btnSaveData:addClickFuntion(self, self.onSaveData);
	self.btnSaveData.anchor = Lua_WindowUtil.getAnchor(1);

	step = step + 1;
	dx = -400 + 200 * ((step % 3) > 0 and (step % 3) or 3);
	dy = -55 - Mathf.Ceil(step / 3) * 60;
	if DataCenter.fightData.bShowSkinBtn then
		self.btnShowSkin = UICreate.createButton(self.content, "跳过按钮-关", dx, dy, 180, 54);
	else
		self.btnShowSkin = UICreate.createButton(self.content, "跳过按钮-开", dx, dy, 180, 54);
	end
	self.btnShowSkin:setStyle(14);
	self.btnShowSkin.txt:setLocation(0, 0, 0);
	self.btnShowSkin.txt.fontSize = 28;
	self.btnShowSkin:addClickFuntion(self, self.onShowSkin);
	self.btnShowSkin.anchor = Lua_WindowUtil.getAnchor(1);

	local bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "black_mask", 0, 354, 640, 620);
	bg.clickScale = false;
	bg.alpha = 0.5;
	bg.anchor = Lua_WindowUtil.getAnchor(7);

	self.dragList = Lua_DragList.new(self.content, 640, 620, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_DebugFightRecordItem, 640, 40, 1);
    self.dragList:setLocation(0, 354, 0);
    self.dragList:setRectAnchor(7);
    
    self:updateFightRecord();
    self:addLuaEvent("FIGHTPLAY_ENTER", self, self.updateFightRecord);
end

function Lua_FightDebugWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	self:superCall("dispose");
end

function Lua_FightDebugWindow:onFightTest(obj)
	if obj ~= nil then
		local num = obj.name;
		if not strIsNullOrEmpty(num) then
			local cmd = ProtoPublic_pb.Proto10111999();
			cmd.cmd_name = "fight";
			cmd.param1 = tonumber(num);
			sendMsg(10111999, cmd);
			self:hide();
			return;
		end
	end

	local cmd = ProtoPublic_pb.Proto10111999();
	cmd.cmd_name = "fight";
	sendMsg(10111999, cmd);
	self:hide();
end

function Lua_FightDebugWindow:onSkillDebugTest()
	self:hide();
	Lua_WindowUtil.openWin("Lua_FightSkillDebugWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugWindow:onFightDebugTest()
	self:hide();
	Lua_WindowUtil.openWin("Lua_FightDebugEditWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightDebugWindow:updateFightRecord()
	self.dragList:setArrayData(DataCenter.fightData.recordIdArr);
end

function Lua_FightDebugWindow:onSaveData()
	local bValue = DataCenter.fightData.bSaveFightData;
	DataCenter.fightData.bSaveFightData = not bValue;
	if DataCenter.fightData.bSaveFightData then
		self.btnSaveData.label = "保存数据-关";
	else
		self.btnSaveData.label = "保存数据-开";
	end
end

function Lua_FightDebugWindow:onShowSkin()
	local bValue = DataCenter.fightData.bShowSkinBtn;
	DataCenter.fightData.bShowSkinBtn = not bValue;
	if DataCenter.fightData.bShowSkinBtn then
		self.btnShowSkin.label = "跳过按钮-关";
	else
		self.btnShowSkin.label = "跳过按钮-开";
	end
end









Lua_DebugFightRecordItem = class("Lua_DebugFightRecordItem", Lua_ListCell);
function Lua_DebugFightRecordItem:ctor(p)
    self:superCall("ctor", p, nil);
end

function Lua_DebugFightRecordItem:buildShowItem()
    self:superCall("buildShowItem");

	self.recordTxt = UICreate.createLabel(self.content, nil, -300, 0, 0, 0, 26);
	self.recordTxt.pivot = UIUtils.Pivot.Left;
	self.recordTxt.horizontalOverflowValue = 1
	self.recordTxt:addClickFuntion(self, self.onPlayRecord);

	self.lookTxt = UICreate.createLabel(self.content, "脚本查看", -20, 0, 0, 0, 26);
	self.lookTxt.pivot = UIUtils.Pivot.Left;
	self.lookTxt.horizontalOverflowValue = 1
	self.lookTxt:resetSize();
	self.lookTxt:addClickFuntion(self, self.onLookTxtClick);

	self.stateTxt = UICreate.createLabel(self.content, "状态查看", 115, 0, 0, 0, 26);
	self.stateTxt.pivot = UIUtils.Pivot.Left;
	self.stateTxt.horizontalOverflowValue = 1
	self.stateTxt:resetSize();
	self.stateTxt:addClickFuntion(self, self.onStateTxtClick);

	self.closeTxt = UICreate.createLabel(self.content, "关闭", 250, 0, 0, 0, 26);
	self.closeTxt.pivot = UIUtils.Pivot.Left;
	self.closeTxt.horizontalOverflowValue = 1
	self.closeTxt:resetSize();
	self.closeTxt:addClickFuntion(self, self.onCloseTxtClick);
end

function Lua_DebugFightRecordItem:dispose()
	self.data = nil;
	self.recordVo = nil;
    self:superCall("dispose");
end

function Lua_DebugFightRecordItem:setData(data)
	self.data = data;
	self.recordVo = DataCenter.fightData:getRecordVoById(data);
    if self.recordVo == nil then
        return;
    end

    self.recordTxt.text = "战斗："..self.recordVo.templateConfig.title;
    self.recordTxt:resetSize();
end

function Lua_DebugFightRecordItem:onPlayRecord()
	if self.data == nil then
		return;
	end
	-- Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(self.data);
	DataCenter.fightData:playRecordByFightId(self.data);
	Lua_WindowUtil.openWin("Lua_FightDebugWindow", Lua_WinParam.ACTION_CLOSE); 
end

function Lua_DebugFightRecordItem:onLookTxtClick()
	if self.recordVo == nil then
		OperateAlert.show("没有该战斗记录：", self.data);
	else
		if self.recordVo.isComplete == false then
			OperateAlert.show(self.data.." 数据未下发完成");
		elseif self.recordVo:writeFightRecord() then
			OperateAlert.show("生成成功");
		end
	end
end

function Lua_DebugFightRecordItem:onCloseTxtClick()
	DataCenter.fightData:removeFight(self.data);
end

function Lua_DebugFightRecordItem:onStateTxtClick()
	Lua_WindowUtil.openWin("Lua_FightPlayerStateWindow", Lua_WinParam.ACTION_OPEN, self.data); 
end