Lua_FightPlayerStateWindow = class("Lua_FightPlayerStateWindow", Lua_Window)
function Lua_FightPlayerStateWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FightPlayerStateWindow";
	self.skinName = "FightPlayerStateWindow_skin";
end

function Lua_FightPlayerStateWindow:buildShowItem()
	self:superCall("buildShowItem");
	self:initData();
end

function Lua_FightPlayerStateWindow:showWin(param)
	self:superCall("showWin", param);
	self:initData();
end

function Lua_FightPlayerStateWindow:dispose()
	self.player = nil;
	self:clearTimer();
	self:superCall("dispose");
end

function Lua_FightPlayerStateWindow:initData()
	if self.showData == nil then
		self:clearTimer();
		self.txt.text = "战斗id为空";
		return;
	end

	local bHaveResult = self:getResult()
	self.resultStr = "是否有结算:"..tostring(bHaveResult).."\n"

	self.player = DataCenter.fightData:getFightPlayerById(self.showData);
	if self.player ~= nil then
		if self.player.isDispose == true then
			self.txt.text = self.resultStr.."战斗播放器已销毁:"..self.showData;
			self:clearTimer();
		else
			self:onUpdatePlayerState();
			if self._bAddTimer ~= true then
				self._bAddTimer = true;
				Lua_CommonUtil.addTimer("onUpdatePlayerState", 0.5, self, self.onUpdatePlayerState)
			end
		end
	else
		self.txt.text = self.resultStr.."获取不到战斗播放器:"..self.showData;
		self:clearTimer();
	end
end

function Lua_FightPlayerStateWindow:clearTimer()
	if self._bAddTimer == true then
		self._bAddTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onUpdatePlayerState)
	end
end

function Lua_FightPlayerStateWindow:onUpdatePlayerState()
	if self.player == nil then
		return;
	end

	local str = self.resultStr
	if self.player.isDispose == true then
		self.player = nil;
		str = str .. "战斗播放器已销毁:"..self.showData.."\n";
		self:clearTimer();
	else
		str = str .. "fightId:"..tostring(self.player._recordId).."\n";
		str = str .. "sceneId:"..tostring(self.player._sceneId).."\n";
		str = str .. "startEffectTime:"..tostring(self.player.startEffectTime).."\n";
		str = str .. "bSceneLoad:"..tostring(self.player.bSceneLoad).."\n";
		str = str .. "loadSceneId:"..tostring(self.player.loadSceneId).."\n";
		str = str .. "bStopPlay:"..tostring(self.player.bStopPlay).."\n";
		str = str .. "isPlayEnd:"..tostring(self.player.isPlayEnd).."\n";
		str = str .. "intervalTime:"..tostring(self.player.intervalTime).."\n";
		str = str .. "approachUnitCount:"..tostring(self.player.approachUnitCount).."\n";
		str = str .. "bPlaySkill:"..tostring(self.player.bPlaySkill).."\n";
		str = str .. "needReplay:"..tostring(self.player.needReplay).."\n";
		str = str .. "bOpenResultWin:"..tostring(self.player.bOpenResultWin).."\n";
		str = str .. "_endRemoveTime:"..tostring(self.player._endRemoveTime).."\n";
		str = str .. "bCheckNextAction:"..tostring(self.player.bCheckNextAction).."\n";
		str = str .. "curRotation:"..tostring(self.player.curRotation).."\n";
		str = str .. "curRound:"..tostring(self.player.curRound).."\n";
		str = str .. "curAction:"..tostring(self.player.curAction).."\n";
		str = str .. "curActionInfo:"..tostring(self.player.curActionInfo).."\n";
		str = str .. "_recordVo.isComplete:"..tostring(self.player._recordVo.isComplete).."\n";
		-- str = str .. "attackVo:"..tostring(self.player.attackVo).."\n";
		str = str .. "bRunBack:"..tostring(self.player.bRunBack).."\n";
	end
	self.txt.text = str;
end

function Lua_FightPlayerStateWindow:getResult()
	local dic = DataCenter.fightData.fightResultDic
	if dic == nil or dic[self.showData] == nil then
		return false
	end
	return true
end