-- 战斗技能调试界面
checkRequire("Lua_FightTemplateConfigData");
Lua_FightSkillDebugWindow = class("Lua_FightSkillDebugWindow", Lua_Window);
function Lua_FightSkillDebugWindow:ctor()
    self:superCall("ctor");
    
    self.windowName = "Lua_FightSkillDebugWindow";
    self.isFullSizeWin = true;
    self.isSingleShowWin = true;
	self.showBackBtn = true;
	self.testFightId = 9876543210;
	self.camActionId = 101032001;
end

function Lua_FightSkillDebugWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.backBtn:setLocation(100, 56, 0);

	self.templateId = 9999;
	self.tampTxt = UICreate.createLabel(self.content, "当前模板: " .. self.templateId, 100, 150, 560, 30, 22);
    self.tampTxt.anchor = Lua_WindowUtil.getAnchor(6);
    self.tampTxt.alignmentValue = 4;
    self.tampTxt.horizontalOverflowValue = 1;

    self.btn = UICreate.createButton(self.content, "开始播放", 0, 0, 177, 58);
    self.btn.anchor = Lua_WindowUtil.getAnchor(6);
    self.btn:setLocation(100, 200, 0);
    self.btn:addClickFuntion(self, self.startAttack);

    self.shakeBtn = UICreate.createButton(self.content, "震屏播放", 0, 0, 177, 58);
    self.shakeBtn.anchor = Lua_WindowUtil.getAnchor(6);
    self.shakeBtn:setLocation(100, 260, 0);
    self.shakeBtn:addClickFuntion(self, self.startShake);

    self.ghostBtn = UICreate.createButton(self.content, "显示残影", 0, 0, 177, 58);
    self.ghostBtn.anchor = Lua_WindowUtil.getAnchor(6);
    self.ghostBtn:setLocation(100, 320, 0);
    self.ghostBtn:addClickFuntion(self, self.createGhost);

    -- self.camActionBtn = UICreate.createButton(self.content, "相机动画", 0, 0, 177, 58);
    -- self.camActionBtn.anchor = Lua_WindowUtil.getAnchor(6);
    -- self.camActionBtn:setLocation(100, 360, 0);
    -- self.camActionBtn:addClickFuntion(self, self.onCamAction);

	local arr = Array();
	arr:add({txt = "战斗模板", winName = "Lua_FightDebugTemplateWindow"});
	arr:add({txt = "添加单位", winName = "Lua_FightDebugHeroWindow"});
	arr:add({txt = "选择技能", winName = "Lua_FightDebugSkillSetWindow"});
	arr:add({txt = "模型展示", winName = "Lua_FightDebugModelShowWindow"});
	arr:add({txt = "特效展示", winName = "Lua_FightDebugEffectShowWindow"});
	arr:add({txt = "飘字展示", winName = "Lua_FightDebugFlyNumShowWindow"});
	arr:add({txt = "血条调试", winName = "Lua_FightDebugHpWindow"});
	arr:add({txt = "BOSS伤害", winName = "Lua_FightDebugBossHurtWindow"});

	self.moveflip = 1;
	self.dragList = Lua_DragList.new(self.content, 530, 58, Lua_AxisDefine.Horizontal);
    self.dragList:setListCell(Lua_FightSkillDebugCell, 180, 58, 1);
    self.dragList:setCellSpacing(10, 10);
    self.dragList:setLocation(90, 56);
    self.dragList:setRectAnchor(7); 
    self.dragList:setArrayData(arr);
	
	self.curShowSceneId = self:getSceneByTampId();
	if self.curShowSceneId ~= nil and self.curShowSceneId > 0 then
		Scene3DManager.instance:OpenSceneBySceneId(self.curShowSceneId, self.testFightId, nil, nil, nil);
	end

	self:addLuaEvent("fightdebug_template_change", self, self.onChangeTemplate);
end

function Lua_FightSkillDebugWindow:createGhost(go)
	local arr = DataCenter.thingData:getThingIds(self.curShowSceneId, self.testFightId);
	if arr ~= nil then
		for i = 1, arr:getSize() do
			local thing = DataCenter.thingData:getThingPlayer(self.curShowSceneId, self.testFightId, arr[i]);
	        if thing ~= nil then
	            thing.player:createGhost();
	            local data = thing.data;
	            if data.px >= 270 then
		            self.moveflip = -1;
		        elseif data.px <= -300 then
		        	self.moveflip = 1;
		        end
		        thing.player:setPosPoint(data.px + 120 * self.moveflip, data.py, data.pz, false);
		        break;
	        end
		end
	end
end

function Lua_FightSkillDebugWindow:startShake(go)
	-- if self.camPos == nil then
	-- 	self.camPos = GlobalVar.mainCamera.gameObject.transform.localPosition;
	-- 	local x = Mathf.Random(-7, 7) / 100;
	-- 	local y = Mathf.Random(-7, 7) / 100;

	-- 	local offsetx = GlobalVar.mainCamera.gameObject.transform.up * x;
	-- 	local offsety = GlobalVar.mainCamera.gameObject.transform.right * y;
	-- 	LuaUtil.setObjPos(GlobalVar.mainCamera.gameObject, self.camPos.x + offsetx.x + offsety.x, self.camPos.y + offsetx.y + offsety.y, self.camPos.z + offsetx.z + offsety.z);

	-- 	local rate = GlobalVar.uiSceneCam.orthographicSize / GlobalVar.mainCamera.orthographicSize;
	-- 	LuaUtil.setObjPos(ContainerUtil.getContainer("UISceneCamera"), rate * y, rate * x, 0);
	-- else
	-- 	LuaUtil.setObjPos(GlobalVar.mainCamera.gameObject, self.camPos.x, self.camPos.y, self.camPos.z); 
	-- 	LuaUtil.setObjPos(ContainerUtil.getContainer("UISceneCamera"), 0, 0, 0);
	-- 	self.camPos = nil;
	-- end
	Lua_WindowUtil.openWin("Lua_ShakeDebugWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_FightSkillDebugWindow:onCamAction(go)
	OperateAlert.show("相机动画："..self.camActionId);
	CameraActionController.instance:playSeries(self.camActionId, 0, 1, Lua_FightDefine.FIGHT_ATTACKER);
end

function Lua_FightSkillDebugWindow:startAttack(go)
	if self.bPlaySkill == true then
		OperateAlert.show("正在播放技能，请稍后")
		return;
	end

	local avo = DataCenter.fightData.testAttackVo;
	if avo == nil then
		OperateAlert.show("未配置技能选项，请选择技能")
		return;
	end

	local skillId = avo.skillId;
	if skillId == nil or skillId <= 0 then
		OperateAlert.show("未选择施法技能，请选择技能")
		return;
	end

	local attackerId = tonumber(tostring(avo.attackerId));
	if attackerId == nil or attackerId <= 0 then
		OperateAlert.show("未选择施法单位，请点击选择技能选择施法单位");
		return;
	end

	local arr = DataCenter.fightData.testTargetsArr;
	local targetCount = arr:getSize();
    if targetCount <= 0 then
    	OperateAlert.show("未选择目标，请点击选择技能选择目标");
		return;
	end

	avo:resetTargets();
	self.bPlaySkill = true;
	for i = 1, targetCount do
		avo:addTargetId(0, arr[i], 1); -- 目标单位
	end
    avo:addLuaCallBack(self, self.attackedCallBack, self.attackComplete, nil);
    avo:start();
end

-- 伤害点
function Lua_FightSkillDebugWindow:attackedCallBack(fid, idx)
    local arr = DataCenter.fightData.testTargetsArr;
    if arr:getSize() >= idx then
    	local thing = DataCenter.thingData:getThingPlayer(self.curShowSceneId, self.testFightId, arr[idx]);
        if thing ~= nil then
            thing.player:updateHealthChange(1, 1, 1);
            thing.player:updateHealth(20);
        end
    end
end

-- 结束
function Lua_FightSkillDebugWindow:attackComplete()
    self.bPlaySkill = false;
end

function Lua_FightSkillDebugWindow:onChangeTemplate(tamp)
	if self.templateId == tamp then
		return;
	end

	self.templateId = tamp;
	self.tampTxt.text = "当前模板: " .. self.templateId;
	local sid = self:getSceneByTampId();
	if sid ~= nil and sid > 0 and sid ~= self.curShowSceneId then
		Scene3DManager.instance:destroyScene(self.curShowSceneId, self.testFightId);
		self.curShowSceneId = sid;
		Scene3DManager.instance:OpenSceneBySceneId(self.curShowSceneId, self.testFightId, nil, nil, nil);
	end
end

function Lua_FightSkillDebugWindow:getSceneByTampId()
	local tamp = Lua_FightTemplateConfigData.getConfigData(self.templateId);
	if tamp ~= nil then
		return tamp.scene_id;
	end
	return nil;
end

function Lua_FightSkillDebugWindow:dispose()
	CameraActionController.instance:clean(self.camActionId);
	Lua_WindowUtil.openWin("Lua_FightDebugTemplateWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_FightDebugHeroWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_FightDebugSkillSetWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_FightDebugModelShowWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_FightDebugEffectShowWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_FightDebugFlyNumShowWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_FightDebugHpWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_FightDebugBossHurtWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_ShakeDebugWindow", Lua_WinParam.ACTION_CLOSE);

	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	local avo = DataCenter.fightData.testAttackVo;
	if avo ~= nil then
		avo:dispose();
		DataCenter.fightData.testAttackVo = nil;
	end
	
	if self.curShowSceneId ~= nil and self.curShowSceneId > 0 then
		Scene3DManager.instance:destroyScene(self.curShowSceneId, self.testFightId);
		self.curShowSceneId = nil;
	end
	self:superCall("dispose");
end



















Lua_FightSkillDebugCell = class("Lua_FightSkillDebugCell", Lua_ListCell);
function Lua_FightSkillDebugCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_FightSkillDebugCell:buildShowItem()
    self:superCall("buildShowItem");
    self.btn = UICreate.createButton(self.content, "按钮", 0, 0, 177, 58);
    self.btn:setMouseEnable(false);
end

function Lua_FightSkillDebugCell:setData(data)
    self.data = data;
    self.btn.label = data.txt;
end

function Lua_FightSkillDebugCell:onPressClick()
	if self.data ~= nil and self.data.winName ~= nil then
		Lua_WindowUtil.openWin(self.data.winName);
	end
end

function Lua_FightSkillDebugCell:dispose()
    self.data = nil;
    self:superCall("dispose");
end
