-- 选项面板
checkRequire("Lua_EffectConfigData");
Lua_FightStageSetSelectWindow = class("Lua_FightStageSetSelectWindow", Lua_Window);
function Lua_FightStageSetSelectWindow:ctor()
    self:superCall("ctor");

    self.w = 703;
    self.h = 1200;
    self.windowName = "Lua_FightStageSetSelectWindow";
    self.showBlackMask = true;
    self.showWinBg = true;
    self.winBgAtlas = "common_altas_1";
    self.winBgSprite = "ui_common_window_007";
    self.showClose = true;
    self.titleNamePosY = self.h / 2 - 48;
    self.btnClosePosX = 296;
    self.btnClosePosY = self.h / 2 - 48;
end

function Lua_FightStageSetSelectWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.noticeTx = UICreate.createLabel(self.content, "筛选：", -250, 480, 100, 40, 26);
    self.noticeTx.pivot = Lua_WindowUtil.getPivot(4);
    self.noticeTx.alignmentValue = 4;
    self.noticeTx.horizontalOverflowValue = 1;
    self.noticeTx.colorStr = Lua_ColorDefine.transColor("846651");

    self.inputBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_edit_001", 0, 480, 400, 40);

    self.inputLabel = UICreate.createInput(self.content, "", 5, 480, 390, 40, 26);
    self.inputLabel.alignmentValue = 3;
    self.inputLabel.colorStr = Lua_ColorDefine.transColor("846651");
    self.inputLabel:ActivateInputField();
    self.inputLabel:onChange(self, self.onCheckList);

    self.dragList = Lua_DragList.new(self.content, 620, 1000, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_FightStageSetSelectItem, 310, 100, 2);
    self.dragList:setLocation(0, -55);
end

function Lua_FightStageSetSelectWindow:showWin(param)
    self:superCall("showWin", param);
    self:updateShowList();
end

function Lua_FightStageSetSelectWindow:onCheckList()
    if self.showArr == nil or self.showArr:getSize() <= 0 then
        return;
    end

    local arr = Array();
    local str = self.inputLabel.text;
    local len = self.showArr:getSize();
    for i = 1, len do
        local v = self.showArr[i];
        local checkStr = v.remark;
        if strIsNullOrEmpty(checkStr) then
            checkStr = v.name;
        end
        if string.find(checkStr, str) ~= nil then
            arr:add(v);
        else
            checkStr = v.id;
            if checkStr == nil then
                checkStr = v.skillId;
            end 
            if checkStr ~= nil and string.find(tostring(checkStr), str) ~= nil then
                arr:add(v);
            end
        end
    end

    if arr:getSize() > 0 then
        self.dragList:setArrayData(arr);
    end
end

function Lua_FightStageSetSelectWindow:updateShowList()
    if self.showData == nil or self.showData == "" then
        self.showArr = Array();
    elseif self.showData == "artifact_id" then -- 神器
        self.showArr = Array();
        local config = getConfig("artifact")
        for k,v in pairs(config) do
            self.showArr:add(v)
        end
    elseif self.showData == "hero_id" then -- 英雄
        self.showArr = Lua_HeroConfigData.getAllHeroConfig()
    elseif self.showData == "skill" then -- 技能1
        self.showArr = Lua_SkillConfigData.getAllSkillConfig();
    elseif self.showData == "effect" then -- 特效
        self.showArr = Lua_EffectConfigData.getAllEffConfig();
    end
    self.dragList:setArrayData(self.showArr);
end

function Lua_FightStageSetSelectWindow:dispose()
    Lua_MsgUtil.callFunc("FIGHTPLAY_STAGESET_SELECT"); -- 移除监听
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    self:superCall("dispose");
end

















Lua_FightStageSetSelectItem = class("Lua_FightStageSetSelectItem", Lua_ListCell);
function Lua_FightStageSetSelectItem:ctor(p)
    self:superCall("ctor", p);
    
end

function Lua_FightStageSetSelectItem:buildShowItem()
    self:superCall("buildShowItem");

    self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_edit_001", 0, 0, 300, 80);

    self.txt = UICreate.createLabel(self.content, "", 0, 0, 280, 40, 26);
    self.txt.pivot = Lua_WindowUtil.getPivot(4);
    self.txt.alignmentValue = 4;
    self.txt.verticalOverflowValue = 1;
    self.txt.colorStr = Lua_ColorDefine.transColor("846651");
end

function Lua_FightStageSetSelectItem:setData(data)
    self._data = data
    if data ~= nil then
        local str = data.remark;
        if strIsNullOrEmpty(str) then
            str = data.name;
        end
        if data.id ~= nil then
            str = str .. "(" .. data.id .. ")";
        elseif data.skillId ~= nil then
            str = str .. "(" .. data.skillId .. ")";
        end
        self.txt.text = str;
    end
end

function Lua_FightStageSetSelectItem:onPressClick()
    Lua_MsgUtil.callFunc("FIGHTPLAY_STAGESET_SELECT", self._data);
    Lua_WindowUtil.openWin("Lua_FightStageSetSelectWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_FightStageSetSelectItem:dispose(go)

    self:superCall("dispose");
end