Lua_ShakeDebugWindow = class("Lua_ShakeDebugWindow", Lua_Window);
function Lua_ShakeDebugWindow:ctor()
    self:superCall("ctor");
    
    self.w = 703;
    self.h = 350;
	self.windowName = "Lua_ShakeDebugWindow";
    self.showWinBg = true;
    self.winBgAtlas = "common_altas_1";
    self.winBgSprite = "ui_common_window_007";
    self.showTitle = true;
    self.titleText = "攻击方";
    self.titleNamePosY = 130;
	self.btnClosePosX = 295;
	self.btnClosePosY = 130;
    self.showClose = true;
end

function Lua_ShakeDebugWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.fpsRate = 30;

	self.timeTxt = UICreate.createLabel(self.content, "震屏持续时间：", -20, 40, 100, 31, 22);
	self.timeTxt.pivot = Lua_WindowUtil.getPivot(5);
	self.timeTxt.alignmentValue = 5;
	self.timeTxt.horizontalOverflowValue = 1;
	self.timeTxt.colorStr = Lua_ColorDefine.transColorStr("8B5E34");

	self.timeBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_edit_001", 20, 40, 200, 31);
	self.timeBg.pivot = Lua_WindowUtil.getPivot(3);

	self.timeInput = UICreate.createInput(self.content, 3, 30, 40, 190, 31, 22);
	self.timeInput.pivot = Lua_WindowUtil.getPivot(3);
	self.timeInput.alignmentValue = 3;
	self.timeInput.colorStr = Lua_ColorDefine.transColor("8B5E34");
	self.timeInput.contentTypeValue = 3;

	self.shakeHTxt = UICreate.createLabel(self.content, "水平震屏幅度：", -20, 0, 100, 31, 22);
	self.shakeHTxt.pivot = Lua_WindowUtil.getPivot(5);
	self.shakeHTxt.alignmentValue = 5;
	self.shakeHTxt.horizontalOverflowValue = 1;
	self.shakeHTxt.colorStr = Lua_ColorDefine.transColorStr("8B5E34");

	self.shakeHBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_edit_001", 20, 0, 200, 31);
	self.shakeHBg.pivot = Lua_WindowUtil.getPivot(3);

	self.shakeHInput = UICreate.createInput(self.content, 30, 30, 0, 190, 31, 22);
	self.shakeHInput.pivot = Lua_WindowUtil.getPivot(3);
	self.shakeHInput.alignmentValue = 3;
	self.shakeHInput.colorStr = Lua_ColorDefine.transColor("8B5E34");
	self.shakeHInput.contentTypeValue = 2;

	self.shakeVTxt = UICreate.createLabel(self.content, "垂直震屏幅度：", -20, -40, 100, 31, 22);
	self.shakeVTxt.pivot = Lua_WindowUtil.getPivot(5);
	self.shakeVTxt.alignmentValue = 5;
	self.shakeVTxt.horizontalOverflowValue = 1;
	self.shakeVTxt.colorStr = Lua_ColorDefine.transColorStr("8B5E34");

	self.shakeVBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_edit_001", 20, -40, 200, 31);
	self.shakeVBg.pivot = Lua_WindowUtil.getPivot(3);

	self.shakeVInput = UICreate.createInput(self.content, 30, 30, -40, 190, 31, 22);
	self.shakeVInput.pivot = Lua_WindowUtil.getPivot(3);
	self.shakeVInput.alignmentValue = 3;
	self.shakeVInput.colorStr = Lua_ColorDefine.transColor("8B5E34");
	self.shakeVInput.contentTypeValue = 2;

    self.shakeBtn = UICreate.createButton(self.content, "开始播放", 0, -100, 177, 58);
    self.shakeBtn:addClickFuntion(self, self.startShake2);
end

function Lua_ShakeDebugWindow:dispose()
	self:superCall("dispose");
end

-- 随机值
function Lua_ShakeDebugWindow:startShake1(go)
	local time = self.timeInput.text;
	local h = self.shakeHInput.text;
	local v = self.shakeVInput.text;
	time = (strIsNullOrEmpty(time) and 3 or tonumber(time)) / self.fpsRate;
	h = (strIsNullOrEmpty(h) and 30 or tonumber(h)) / 100;
	v = (strIsNullOrEmpty(v) and 30 or tonumber(v)) / 100;
	-- ShakeUtil.instance:beginShake(time, Mathf.Random(-h, h) / 100, Mathf.Random(-v, v) / 100, 0);
	ShakeUtil.instance:beginShake(time, Mathf.Random(-h, h) / 100, 0);
end

-- 固定值位移
function Lua_ShakeDebugWindow:startShake2(go)
	local time = self.timeInput.text;
	local h = self.shakeHInput.text;
	local v = self.shakeVInput.text;
	time = (strIsNullOrEmpty(time) and 3 or tonumber(time)) / self.fpsRate;
	h = (strIsNullOrEmpty(h) and 30 or tonumber(h)) / 100;
	v = (strIsNullOrEmpty(v) and 30 or tonumber(v)) / 100;
	ShakeUtil.instance:beginShake(time / 2, 0, h, v);
end