Lua_FightDebugSetItem = class("Lua_FightDebugSetItem", Lua_DisplayObject)
function Lua_FightDebugSetItem:ctor(p)
	self:superCall("ctor", p, "FightDebugSetItem_skin")
end

function Lua_FightDebugSetItem:buildShowItem()
	self:superCall("buildShowItem")
end

function Lua_FightDebugSetItem:dispose()
	self.owner = nil
	self.callBack = nil
	self.data = nil
	self:superCall("dispose")
end

function Lua_FightDebugSetItem:setCallBack(owner, callBack)
	self.owner = owner
	self.callBack = callBack
end

function Lua_FightDebugSetItem:setData(data)
	self.data = data
end

function Lua_FightDebugSetItem:setKey(key, value)
	self.key = key
	self.value = value
	if key == "sort_id" then
		self:setName("英雄")
	elseif key == "position" then
		self:setName("站位")
	elseif key == "level" then
		self:setName("等级")
	elseif key == "attr" then

	elseif key == "skill" then
		self:setName("技能"..value)
	end

	if key == "position" or key == "level" then
		self.txtInput.contentTypeValue = 2
	else
		self.txtInput.contentTypeValue = 0
	end

	if key == "sort_id" or key == "skill" then
		self.bgInput.mouseEnable = true
		self.bgInput:addClickFuntion(self, self.onClick)
		self.txtInput.inputMouseEnable = false
		self.txtInput:onEndEdit(nil, nil)
	else
		self.bgInput.mouseEnable = false
		self.bgInput:removeClickFuntion(self, self.onClick)
		self.txtInput.inputMouseEnable = true
		self.txtInput:onEndEdit(self, self.onInputEnd)
	end

	self:updateShowInfo()
end

function Lua_FightDebugSetItem:setName(value)
	self.txtName.text = value
end

function Lua_FightDebugSetItem:updateShowInfo()
	if self.key == "sort_id" then
		local config = getConfig("artifact", self.data.sort_id)
		if config == nil then
			config = Lua_HeroConfigData.getConfig(self.data.sort_id)
		end
		if config then
			local str = config.remark
			if strIsNullOrEmpty(str) then
				str = config.name
			end
			self.txtInput.text = str .. "(" .. self.data.sort_id .. ")"
		else
			self.txtInput.text = nil
		end
	elseif self.key == "skill" then
		local id = self.data.skill_list[self.value]
		local config = Lua_SkillConfigData.getConfigData(id)
		if config then
			local str = config.remark
			if strIsNullOrEmpty(str) then
				str = config.name
			end
			self.txtInput.text = str .. "(" .. id .. ")"
		else
			self.txtInput.text = nil
		end
	elseif self.key == "position" then
		self.txtInput.text = self.data.position
	elseif self.key == "level" then
		self.txtInput.text = self.data.level
	elseif self.key == "attr" then
		self.txtInput.text = self.data.prop[self.value]
	end
end

function Lua_FightDebugSetItem:onClick()
	if self.key == "sort_id" then
		if self.data.position == 0 then
			Lua_WindowUtil.openWin("Lua_FightStageSetSelectWindow", Lua_WinParam.ACTION_AUTO, "artifact_id")
		else
			Lua_WindowUtil.openWin("Lua_FightStageSetSelectWindow", Lua_WinParam.ACTION_AUTO, "hero_id")
		end
	else
		Lua_WindowUtil.openWin("Lua_FightStageSetSelectWindow", Lua_WinParam.ACTION_AUTO, self.key)
	end
	self:addLuaEvent("FIGHTPLAY_STAGESET_SELECT", self, self.onSelected)
end

function Lua_FightDebugSetItem:onSelected(data)
	if data then
		if self.key == "sort_id" then
			self.data.sort_id = data.id
		elseif self.key == "skill" then
			self.data.skill_list[self.value] = data.skillId
		end
		self:updateShowInfo()
	end
	self:removeLuaEvent("FIGHTPLAY_STAGESET_SELECT", self, self.onSelected)
end

function Lua_FightDebugSetItem:onInputEnd()
	local value = tonumber(self.txtInput.text)
	local bChange = false
	if self.key == "position" then
		bChange = self.data.position ~= value
		self.data.position = value
	elseif self.key == "level" then
		bChange = self.data.level ~= value
		self.data.level = value
	elseif self.key == "attr" then
		bChange = self.data.prop[self.value] ~= value
		self.data.prop[self.value] = value
	end
	if bChange and self.owner and self.callBack then
		self.callBack(self.owner)
	end
end