Lua_IdsDetailShowWindow = class("Lua_IdsDetailShowWindow", Lua_Window)
function Lua_IdsDetailShowWindow:ctor()
	self:superCall("ctor");

	self.w = 0;
	self.h = 0;
	self.layer = MainWinDefine.MAX_TOP_LAYER;
	self.windowName = "Lua_IdsDetailShowWindow";
	self.skinName = "IdsDetailShowWindow_skin";
end

function Lua_IdsDetailShowWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winBg.clickScale = false;
	self.winBg:addMousDownFuntion(self, self.onMouseDownHandle);
	self.winBg:addMouseUpFuntion(self, self.onMouseUpHandle);

	self.dragList = Lua_DragList.new(self.content, 650, 660, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_IdsDetailCell, 650, 50, 1);
    self.dragList:setLocation(0, -25);
end

function Lua_IdsDetailShowWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	self:endTimer();
	self:superCall("dispose");
end

function Lua_IdsDetailShowWindow:showWin(param)
    self:superCall("showWin", param);
    if param ~= nil then
        self.dragList:setArrayData(param);
    end
end

function Lua_IdsDetailShowWindow:onMouseDownHandle(go)
	self.canDrag = true;
	self.startMouseX = CommonUtil.mousePositionX;
	self.startMouseY = CommonUtil.mousePositionY;
	self:startTimer();
end

function Lua_IdsDetailShowWindow:onMouseUpHandle(go)
	self.canDrag = false;
end

function Lua_IdsDetailShowWindow:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_IdsListShowWindow", 0.01, self, self.onTimer, nil, -1);
	end
end

function Lua_IdsDetailShowWindow:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_IdsDetailShowWindow:onTimer()
	if self.canDrag ~= true then
		self:endTimer();
		return
	end

    local dx = CommonUtil.mousePositionX - self.startMouseX;
    local dy = CommonUtil.mousePositionY - self.startMouseY;
    self.startMouseX = CommonUtil.mousePositionX;
    self.startMouseY = CommonUtil.mousePositionY;

    local vec = self.content.transform.localPosition;
    local targetX = vec.x + dx;
    local vw = UnityEngine.Screen.width / GlobalVar.scaleRatio;
    if targetX < -(vw - self.w)/2 or targetX > (vw - self.w)/2 then
    	return;
    end

    local targetY = vec.y + dy;
    local vh = UnityEngine.Screen.height / GlobalVar.scaleRatio;
    if targetY < -(vh - self.h)/2 or targetY > (vh - self.h)/2 then
    	return;
    end

    LuaUtil.setObjPos(self.content, targetX, targetY, vec.z);
end






















Lua_IdsDetailCell = class("Lua_IdsDetailCell", Lua_ListCell);
function Lua_IdsDetailCell:ctor(p)
    self:superCall("ctor", p, "IdsDetailCell_skin");
end

function Lua_IdsDetailCell:buildShowItem()
    self:superCall("buildShowItem");
    self.copyBtn:addClickFuntion(self, self.onCopyClick);
end

function Lua_IdsDetailCell:setData(data)
    self._data = data;
    if data ~= nil then
	    self.idTxt.text = data.id.."";
	    self.descTxt.text = data.desc;
	end
end

function Lua_IdsDetailCell:dispose(go)
	self._data = nil;
    self:superCall("dispose");
end

function Lua_IdsDetailCell:onCopyClick()
	if self._data == nil then return; end
	LanUtil.copyToClipboard(self._data.id);
	OperateAlert.show("拷贝成功");
end