-- 唯一id集合界面
Lua_IdsListShowWindow = class("Lua_IdsListShowWindow", Lua_Window)
function Lua_IdsListShowWindow:ctor()
	self:superCall("ctor");

	self.w = 0;
	self.h = 0;
	self.layer = MainWinDefine.MAX_TOP_LAYER;
	self.windowName = "Lua_IdsListShowWindow";
	self.skinName = "IdsListShowWindow_skin";
end

function Lua_IdsListShowWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winBg.clickScale = false;
	self.winBg:addMousDownFuntion(self, self.onMouseDownHandle);
	self.winBg:addMouseUpFuntion(self, self.onMouseUpHandle);

	self.list = Array();
	self.list:add({ label = "英雄ID", owner = self, fun = self.onHeroClick });

	self.btnArr = Array();
	for i = 1, self.list:getSize() do
		local posX = ((i - 1) % 4) * 165 - 245;
		local posY = 340 + Mathf.Floor((i - 1) / 4) * 60 * -1;
		local btn = UICreate.createButton(self.content, self.list[i].label, posX, posY, 141, 54);
		btn.name = "btn"..i;
		btn.siblingIndex = i + 10;
		btn:setStyle(14)
		btn.txt:setLocation(0, 0, 0)
		btn.txt.fontSize = 28
		btn:addClickFuntion(self.list[i].owner, self.list[i].fun);
		self.btnArr:add(btn);
	end
end

function Lua_IdsListShowWindow:dispose()
	if self.list ~= nil then
		while self.list:getSize() > 0 do
			local obj = self.list:remove(1);
			obj.label = nil;
			obj.owner = nil;
			obj.fun = nil;
		end
		self.list:clear();
		self.list = nil;
	end

	if self.btnArr ~= nil then
		self.btnArr:dispose();
		self.btnArr:clear();
		self.btnArr = nil;
	end

	self:endTimer();
	self:superCall("dispose");
end

function Lua_IdsListShowWindow:onMouseDownHandle(go)
	self.canDrag = true;
	self.startMouseX = CommonUtil.mousePositionX;
	self.startMouseY = CommonUtil.mousePositionY;
	self:startTimer();
end

function Lua_IdsListShowWindow:onMouseUpHandle(go)
	self.canDrag = false;
end

function Lua_IdsListShowWindow:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_IdsListShowWindow", 0.01, self, self.onTimer, nil, -1);
	end
end

function Lua_IdsListShowWindow:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_IdsListShowWindow:onTimer()
	if self.canDrag ~= true then
		self:endTimer();
		return
	end

    local dx = CommonUtil.mousePositionX - self.startMouseX;
    local dy = CommonUtil.mousePositionY - self.startMouseY;
    self.startMouseX = CommonUtil.mousePositionX;
    self.startMouseY = CommonUtil.mousePositionY;

    local vec = self.content.transform.localPosition;
    local targetX = vec.x + dx;
    local vw = UnityEngine.Screen.width / GlobalVar.scaleRatio;
    if targetX < -(vw - self.w)/2 or targetX > (vw - self.w)/2 then
    	return;
    end

    local targetY = vec.y + dy;
    local vh = UnityEngine.Screen.height / GlobalVar.scaleRatio;
    if targetY < -(vh - self.h)/2 or targetY > (vh - self.h)/2 then
    	return;
    end

    LuaUtil.setObjPos(self.content, targetX, targetY, vec.z);
end

function Lua_IdsListShowWindow:onHeroClick()
	local arr = Array();
	local heroArr = DataCenter.heroData.allHeroUidArr;
	if heroArr ~= nil and heroArr:getSize() > 0 then
		for i = 1, heroArr:getSize() do
			local obj = {};
			obj.id = heroArr[i];
			local heroVo = DataCenter.heroData:getItemByUniqueId(heroArr[i]);
			obj.desc = heroVo.config.name .. " Lv." .. heroVo.level;
			arr:add(obj);
		end
	end
	Lua_WindowUtil.openWin("Lua_IdsDetailShowWindow", Lua_WinParam.ACTION_OPEN, arr);
	self:hide();
end