-- 客户端模拟发包
Lua_MsgSimulateSendWindow = class("Lua_MsgSimulateSendWindow", Lua_Window);
function Lua_MsgSimulateSendWindow:ctor()
    self:superCall("ctor");

    self.isFullPaving = true;
    self.isFullSizeWin = true;
    self.windowName = "Lua_MsgSimulateSendWindow";
    self.skinName = "MsgSimulateSendWindow_skin";
    self.showBlackMask = true;
    self.showWinBg = true;
    self.showClose = true;
end

function Lua_MsgSimulateSendWindow:buildShowItem()
    self:superCall("buildShowItem");
    self:addLuaEvent("MsgSimulateSend_Selected", self, self.onSelectSimulateMsg);
    self:addLuaEvent("MsgSimulateProto_AddBtn_Click", self, self.onUpdateMsgSimulateProto);

    self.shaixuanTxt.text = "";
    self.shaixuanTxt:onChange(self, self.onCheckList);
    self.sendBtn:addClickFuntion(self, self.onSendClick);
    self.sendBtn:setEnable(false);
    self.msgIdTitle:setEnable(false);
    self.msgIdTxt.text = "";
    self.sendTitle:setEnable(false);
    self.sendBg:setEnable(false);
    self.sendTxt:setEnable(false);
    self.msgDescTxt.text = "";

    self.dragList = Lua_DragList.new(self.content, 700, 415, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_MsgSimulateSendCell, 700, 60, 1);
    self.dragList:setLocation(0, -357);
    self.dragList:setRectAnchor(1);

    self.dragContainer = Lua_DragContainer.new(self.content, 700, 630, Lua_AxisDefine.Vertical, true);
    self.dragContainer:setRectPivot(7);
    self.dragContainer:setLocation(0, -700, 0);

    self:showMsg();
end

function Lua_MsgSimulateSendWindow:dispose()
    if self.decodeMsgArr ~= nil then
        self.decodeMsgArr:clear();
        self.decodeMsgArr:dispose();
        self.decodeMsgArr = nil;
    end

    if self.showMsgArr ~= nil then
        self.showMsgArr:clear();
        self.showMsgArr:dispose();
        self.showMsgArr = nil;
    end

    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end

    if self.dragContainer ~= nil then
        self.dragContainer:dispose()
        self.dragContainer = nil;
    end

    self:superCall("dispose");
end

function Lua_MsgSimulateSendWindow:showWin(param)
    self:superCall("showWin", param);
    if param ~= nil then
        self:showSimulateMsg(param.msgId, param.msgContent);
    end
end

-- 列表筛选
function Lua_MsgSimulateSendWindow:onCheckList()
    self:showMsg(self.shaixuanTxt.text);
end

function Lua_MsgSimulateSendWindow:showMsg(msgId)
    if self.showMsgArr == nil then
        self.showMsgArr = Array();
    else
        self.showMsgArr:clear();
    end

    local arr = DataCenter.loginData.protoMsgArr;
    if arr == nil then
        return;
    end

    for i = 1, arr:getSize() do
        local mId = arr[i];
        local obj = DataCenter.loginData:getProtoInfo(mId);
        if obj ~= nil then
            if not strIsNullOrEmpty(msgId) then 
                if string.find(mId, msgId) ~= nil or string.find(obj.desc, msgId) ~= nil then
                    self.showMsgArr:add(obj);
                end
            else
                self.showMsgArr:add(obj);
            end
        end
    end
    self.dragList:setArrayData(self.showMsgArr);
end

function Lua_MsgSimulateSendWindow:onSendClick()
    if self.sendMsgId == nil then
        OperateAlert.show("请选择需要发送的消息号");
        return;
    end

    -- 解析消息体
    local cmd = nil;
    if self.sendProto ~= nil then
        cmd = getProtoMsg("Proto"..self.sendMsgId);
        if cmd ~= nil then
            self:generateCmd(cmd, self.sendProto);
        end
    end

    local txt = self.sendTxt.text;
    local num = strIsNullOrEmpty(txt) and 1 or tonumber(txt);
    num = num <= 0 and 1 or num;
    for i = 1, num do
        sendMsg(self.sendMsgId, cmd);
    end

    OperateAlert.show(self.sendMsgId .. "发送成功 *" .. num);
end

function Lua_MsgSimulateSendWindow:generateCmd(cmd, tb)
    if cmd == nil or tb == nil then
        return;
    end

    for k, v in pairs(tb) do
        if v.arr == nil then
            if v.typeStr == "number" then
                cmd[k] = tonumber(v.val);
            elseif v.typeStr == "string" then
                cmd[k] = tostring(v.val);
            elseif v.tab ~= nil then
                local ttb = v.val;
                if ttb ~= nil then
                    self:generateCmd(cmd[k], ttb);
                end
            end
        else
            if v.typeStr == "number" then
                for i = 1, v.arr:getSize() do
                    cmd[k]:append(tonumber(v.arr[i]));
                end
            elseif v.typeStr == "string" then
                for i = 1, v.arr:getSize() do
                    cmd[k]:append(tostring(v.arr[i]));
                end
            elseif v.tab ~= nil then -- 结构体
                for i = 1, v.arr:getSize() do
                    local ttb = v.arr[i];
                    local ccmd = getProtoMsg(v.tab.name);
                    if ccmd ~= nil then
                        self:generateCmd(ccmd, ttb);
                        cmd[k]:addToList(ccmd);
                    end
                end
            end
        end
    end
end

function Lua_MsgSimulateSendWindow:onUpdateMsgSimulateProto()
    if self.dragContainer ~= nil then
        self.dragContainer:updateChildData();
    end
end

function Lua_MsgSimulateSendWindow:onSelectSimulateMsg(msgId)
    self:showSimulateMsg(msgId, nil);
end

function Lua_MsgSimulateSendWindow:showSimulateMsg(msgId, msgContent)
    self.sendMsgId = nil;
    self.sendProto = nil;
    self.sendBtn:setEnable(false);
    self.sendTitle:setEnable(false);
    self.sendBg:setEnable(false);
    self.sendTxt:setEnable(false);
    self.msgDescTxt.text = "";
    self.dragContainer:clearList();
    local protoInfo = DataCenter.loginData:getProtoInfo(msgId.."");
    if protoInfo == nil then
        return;
    end
    
    if not strIsNullOrEmpty(msgContent) then
        local mp = LuaUtil.parseMsgString(msgId, msgContent);
        if mp ~= nil then
            local msg = getProtoMsg("Proto"..msgId);
            if msg ~= nil then
                msg:ParseFromString(mp.data);
                self.msgDescTxt.text = protoInfo.desc ~= nil and "描述："..protoInfo.desc or "";
                self.msgIdTxt.text = msgId.."";
                self.sendBtn:setEnable(true);
                self.msgIdTitle:setEnable(true);
                self.sendTitle:setEnable(true);
                self.sendBg:setEnable(true);
                self.sendTxt:setEnable(true);

                local c = checkRequire("Proto"..msgId);
                if c ~= nil then
                    local bt = c.getBufTable();
                    self.sendProto = Lua_MsgSimulateSendWindow.generateProtoObj(bt, msg);
                    if self.sendProto ~= nil then
                        for k, v in pairs(self.sendProto) do
                            local typeStr = v.typeStr;
                            if v.arr == nil and typeStr == "number" then
                                self.dragContainer:addSubContainer(Lua_MsgSimulateProtoValItem, v, false);
                            elseif v.arr == nil and typeStr == "string" then
                                self.dragContainer:addSubContainer(Lua_MsgSimulateProtoValItem, v, false);
                            else
                                self.dragContainer:addSubContainer(Lua_MsgSimulateProtoAddItem, v, false);
                            end
                        end
                    end

                    self.sendMsgId = msgId;
                    self.dragContainer:updateChildPos();
                end
            end
        else
            self.sendMsgId = msgId;
            self.sendBtn:setEnable(true);
            self.msgIdTitle:setEnable(true);
            self.msgIdTxt.text = msgId.."(无数据)";
            self.sendTitle:setEnable(true);
            self.sendBg:setEnable(true);
            self.sendTxt:setEnable(true);
            self.msgDescTxt.text = protoInfo.desc ~= nil and "描述："..protoInfo.desc or "";
        end
    else --拿后端提供的消息列表判断
        if protoInfo.isProto then -- 有结构体
            local pb = getProtoMsg("Proto"..msgId);
            if pb == nil then return; end
            self.msgDescTxt.text = protoInfo.desc ~= nil and "描述："..protoInfo.desc or "";
            self.msgIdTxt.text = msgId.."";
            self.sendBtn:setEnable(true);
            self.msgIdTitle:setEnable(true);
            self.sendTitle:setEnable(true);
            self.sendBg:setEnable(true);
            self.sendTxt:setEnable(true);
            
            local c = checkRequire("Proto"..msgId);
            if c ~= nil then
                local bt = c.getBufTable();
                self.sendProto = Lua_MsgSimulateSendWindow.generateProtoObj(bt, msg);
                if self.sendProto ~= nil then
                    for k, v in pairs(self.sendProto) do
                        -- print("sendProto", k, v, v.name, v.typeStr, v.arr, v.tab);
                        local typeStr = v.typeStr;
                        if v.arr == nil and typeStr == "number" then
                            self.dragContainer:addSubContainer(Lua_MsgSimulateProtoValItem, v, false);
                        elseif v.arr == nil and typeStr == "string" then
                            self.dragContainer:addSubContainer(Lua_MsgSimulateProtoValItem, v, false);
                        else
                            self.dragContainer:addSubContainer(Lua_MsgSimulateProtoAddItem, v, false);
                        end
                    end
                end

                self.sendMsgId = msgId;
                self.dragContainer:updateChildPos();
            end
        else 
            self.sendMsgId = msgId;
            self.sendBtn:setEnable(true);
            self.msgIdTitle:setEnable(true);
            self.msgIdTxt.text = msgId.."(无数据)";
            self.sendTitle:setEnable(true);
            self.sendBg:setEnable(true);
            self.sendTxt:setEnable(true);
            self.msgDescTxt.text = protoInfo.desc ~= nil and "描述："..protoInfo.desc or "";
        end
    end
end

function Lua_MsgSimulateSendWindow.generateProtoObj(tab, msg)
    if tab == nil then 
        return; 
    end

    local protoObj = {};
    for k, v in pairs(tab.fields) do
        local name = v.name;
        local msgVal = msg ~= nil and msg[name] or nil;
        local default_value = msgVal ~= nil and msgVal or v.default_value;
        if default_value ~= nil then
            local typeStr = type(default_value);
            if typeStr == "number" then
                -- print("protoObj number", name, defaultVal);
                protoObj[name] = {name = name, val = default_value, typeStr = "number"};
            elseif typeStr == "string" then
                -- print("protoObj string", name, defaultVal);
                protoObj[name] = {name = name, val = default_value, typeStr = "string"};
            elseif typeStr == "table" then
                local label = v.label;
                if label == 3 then -- 数组
                    local subProtoObj = {};
                    subProtoObj.name = name;
                    subProtoObj.arr = Array();
                    subProtoObj.tab = v.message_type;
                    if subProtoObj.tab == nil then
                        subProtoObj.typeStr = v.type == 9 and "number" or "string";
                    end
                    protoObj[name] = subProtoObj;
                    if default_value ~= nil and #default_value > 0 then
                        for i = 1, #default_value do
                            if subProtoObj.tab == nil then -- 数值数组
                                subProtoObj.arr:add(default_value[i]);
                            else
                                local ssubProtoObj = Lua_MsgSimulateSendWindow.generateProtoObj(subProtoObj.tab, default_value[i]);
                                subProtoObj.arr:add(ssubProtoObj);
                            end
                        end
                    end
                    -- print("protoObj 数组", name, subProtoObj.typeStr, subProtoObj.arr:getSize());
                else -- 对象
                    local bt = v.message_type;
                    if bt ~= nil then
                        local subProtoObj = {};
                        subProtoObj.name = name;
                        subProtoObj.val = Lua_MsgSimulateSendWindow.generateProtoObj(bt, default_value);
                        subProtoObj.tab = bt;
                        protoObj[name] = subProtoObj;
                        -- print("protoObj 对象", name);
                    end
                end
            end
        else
            if v.message_type ~= nil then
                local label = v.label;
                if label == 3 then -- 数组
                    local subProtoObj = {};
                    subProtoObj.name = name;
                    subProtoObj.arr = Array();
                    subProtoObj.tab = v.message_type;
                    protoObj[name] = subProtoObj;
                    -- print("protoObj 数组 default_value = nil", name);
                else -- 对象
                    local subProtoObj = {};
                    subProtoObj.name = name;
                    subProtoObj.val = Lua_MsgSimulateSendWindow.generateProtoObj(v.message_type, nil);
                    subProtoObj.tab = v.message_type;
                    protoObj[name] = subProtoObj;
                    -- print("protoObj 对象 default_value = nil", name, protoObj[name].name);
                end
            end
        end
    end 

    return protoObj;
end






















Lua_MsgSimulateSendCell = class("Lua_MsgSimulateSendCell", Lua_ListCell);
function Lua_MsgSimulateSendCell:ctor(p)
    self:superCall("ctor", p, "MsgSimulateSendCell_skin");
end

function Lua_MsgSimulateSendCell:buildShowItem()
    self:superCall("buildShowItem");
    self.simulateBtn:addClickFuntion(self, self.onSimulateClick);
end

function Lua_MsgSimulateSendCell:setData(data)
    self._data = data;
    if data == nil then
        self.msgId.text = "";
        self.descTxt.text = "";
    else
        self.msgId.text = data.msgId .. "";
        self.descTxt.text = data.desc;
    end
end

function Lua_MsgSimulateSendCell:dispose(go)
    self._data = nil;
    self:superCall("dispose");
end

function Lua_MsgSimulateSendCell:onSimulateClick()
    if self._data == nil then return; end
    Lua_MsgUtil.callFunc("MsgSimulateSend_Selected", self._data.msgId);
end








Lua_MsgSimulateProtoValItem = class("Lua_MsgSimulateProtoValItem", Lua_DragContainerItem);
function Lua_MsgSimulateProtoValItem:ctor(p)
    self:superCall("ctor", p, "MsgSimulateProtoValItem_skin", false);
end

function Lua_MsgSimulateProtoValItem:buildShowItem()
    self:superCall("buildShowItem");

    self.attriName.text = "";
    self.attriVal.text = "";
    self.attriVal:onChange(self, self.onAttriValChange);
end

function Lua_MsgSimulateProtoValItem:setValChangeCallBack(tb, fun)
    self._cbTab = tb;
    self._cbFun = fun;
end

function Lua_MsgSimulateProtoValItem:onAttriValChange()
    if self.typeStr ~= nil then
        if self.typeStr == "number" then
            local num = tonumber(self.attriVal.text);
            if num == nil then
                if self.protoObj ~= nil then
                    self.attriVal.text = self.protoObj.val .. "";
                else
                    self.attriVal.text = self.defaultVal .. "";
                end
            else
                if self.protoObj ~= nil then
                    self.protoObj.val = num;
                else
                    self.defaultVal = num;
                    -- 回调数值变化
                    if self._cbTab ~= nil and self._cbFun ~= nil then
                        self._cbFun(self._cbTab, self.defaultVal);
                    end 
                end
            end
        elseif self.typeStr == "string" then
            if self.protoObj ~= nil then
                self.protoObj.val = self.attriVal.text;
            else
                self.defaultVal = self.attriVal.text;
                -- 回调数值变化
                if self._cbTab ~= nil and self._cbFun ~= nil then
                    self._cbFun(self._cbTab, self.defaultVal);
                end 
            end
        end
    end
end

function Lua_MsgSimulateProtoValItem:clean()
    self.protoObj = nil;
    self.typeStr = nil;
    self.defaultVal = nil;
    self._cbTab = nil;
    self._cbFun = nil;
    self:superCall("clean");
end

function Lua_MsgSimulateProtoValItem:dispose()
    self.protoObj = nil;
    self.typeStr = nil;
    self.defaultVal = nil;
    self._cbTab = nil;
    self._cbFun = nil;
    self:superCall("dispose");
end

function Lua_MsgSimulateProtoValItem:getWidth()
    return 700;
end

function Lua_MsgSimulateProtoValItem:getHeight()
    return 40;
end

function Lua_MsgSimulateProtoValItem:setData(obj)
    self.protoObj = obj;
    self.typeStr = obj.typeStr;
    self.attriName.text = obj.name.."("..self.typeStr..")：";
    self.attriVal.text = ""..obj.val;
end

function Lua_MsgSimulateProtoValItem:setShowVal(typeStr, val)
    self.protoObj = nil;
    self.defaultVal = val;
    self.typeStr = typeStr;
    self.attriName.text = "("..self.typeStr..")：";
    self.attriVal.text = ""..val;
end













Lua_MsgSimulateProtoAddItem = class("Lua_MsgSimulateProtoAddItem", Lua_DragContainerItem);
function Lua_MsgSimulateProtoAddItem:ctor(p)
    self:superCall("ctor", p, "MsgSimulateProtoAddItem_skin", false);
end

function Lua_MsgSimulateProtoAddItem:buildShowItem()
    self:superCall("buildShowItem");

    self._ch = 40;
    self.offsetX = 40;
    self.attriName.text = "";
    self.addBtn:addClickFuntion(self, self.onAddBtnClick);
end

function Lua_MsgSimulateProtoAddItem:setCallBack(tb, fun)
    self._cbTab = tb;
    self._cbFun = fun;
end

function Lua_MsgSimulateProtoAddItem:setOffsetX(val)
    self.offsetX = val;
end

function Lua_MsgSimulateProtoAddItem:onAddBtnClick()
    if self.protoItemArr == nil then
        self.protoItemArr = Array();
    end

    -- print("1self._ch", self._ch, self.offsetX, self.protoObj.typeStr);
    local val = nil;
    local item = Lua_MsgSimulateProtoGroupItem.new(self.content);
    if self.protoObj.tab == nil then -- 数值
        item:setCallBack(self, self.onDelProto, self.onChangeProto, self.onItemValChange);
    else
        item:setCallBack(self, self.onDelProto, self.onChangeProto);
    end
    item:setRectAnchor(1);
    item:setRectSize(700, 40);
    if self.protoObj.typeStr == "number" then
        val = 0;
    elseif self.protoObj.typeStr == "string" then
        val = "";
    else
        val = Lua_MsgSimulateSendWindow.generateProtoObj(self.protoObj.tab, nil);
    end
    item:setData(val, self.protoObj.typeStr);
    item:setLocation(self.offsetX, -20-self._ch);
    self._ch = self._ch + item:getHeight();
    self.protoItemArr:add(item);
    self.bg:SetDimensions(1440, self._ch - 2);
    -- print("2self._ch", self._ch, item:getHeight(), self._cbTab ~= nil);

    self.protoObj.arr:add(val);
    if self._cbTab ~= nil and self._cbFun ~= nil then
        self._cbFun(self._cbTab, self);
    end 
    Lua_MsgUtil.callFunc("MsgSimulateProto_AddBtn_Click", self.protoObj);
end

function Lua_MsgSimulateProtoAddItem:onDelProto(item)
    if self.protoItemArr == nil then
        return;
    end

    local idx = self.protoItemArr:indexOf(item);
    if idx ~= nil then
        local subH = self.protoItemArr[idx]:getHeight();
        self.protoItemArr[idx]:dispose();
        self.protoItemArr:remove(idx);
        for i = idx, self.protoItemArr:getSize() do
            local it = self.protoItemArr[i];
            it:setLocation(self.offsetX, it.posY + subH);
        end

        -- 移除列表
        self.protoObj.arr:remove(idx);
        self._ch = self._ch - subH;
        self.bg:SetDimensions(1440, self._ch - 2);
        if self._cbTab ~= nil and self._cbFun ~= nil then
            self._cbFun(self._cbTab, self);
        end 
        Lua_MsgUtil.callFunc("MsgSimulateProto_AddBtn_Click", self.protoObj);
    end
end

function Lua_MsgSimulateProtoAddItem:onChangeProto(item)
    if self.protoItemArr == nil then
        return;
    end

    self._ch = 40;
    local bChange = false;
    for i = 1, self.protoItemArr:getSize() do
        local it = self.protoItemArr[i];
        it:setLocation(self.offsetX, -20-self._ch);
        self._ch = self._ch + it:getHeight();
        if item == it then
            bChange = true;
        end
    end

    if bChange then
        self.bg:SetDimensions(1440, self._ch - 2);
        Lua_MsgUtil.callFunc("MsgSimulateProto_AddBtn_Click", self.protoObj);
    end
end

function Lua_MsgSimulateProtoAddItem:onItemValChange(item, val)
    if self.protoObj == nil or self.protoObj.label ~= 3 then
        return;
    end

    for i = 1, self.protoItemArr:getSize() do
        if item == self.protoItemArr[i] then
            self.protoObj.arr[i] = val;
            break;
        end
    end
end

function Lua_MsgSimulateProtoAddItem:clean()
    self.protoObj = nil;
    self._cbTab = nil;
    self._cbFun = nil;
    if self.protoItemArr ~= nil then
        local len = self.protoItemArr:getSize();
        while (len > 0) do
            local item = self.protoItemArr:remove(len);
            item:dispose();
            len = len - 1;
        end
    end

    self:superCall("clean");
end

function Lua_MsgSimulateProtoAddItem:dispose()
    self.protoObj = nil;
    self._cbTab = nil;
    self._cbFun = nil;
    if self.protoItemArr ~= nil then
        local len = self.protoItemArr:getSize();
        while (len > 0) do
            local item = self.protoItemArr:remove(len);
            item:dispose();
            len = len - 1;
        end

        self.protoItemArr:dispose();
        self.protoItemArr = nil;
    end

    self:superCall("dispose");
end

function Lua_MsgSimulateProtoAddItem:getWidth()
    return 700;
end

function Lua_MsgSimulateProtoAddItem:getHeight()
    return self._ch;
end

function Lua_MsgSimulateProtoAddItem:setData(obj)
    if self.protoObj == obj then
        return;
    end

    self._ch = 40;
    if self.protoItemArr ~= nil then
        local len = self.protoItemArr:getSize();
        while (len > 0) do
            local item = self.protoItemArr:remove(len);
            item:dispose();
            len = len - 1;
        end
    end

    self.protoObj = obj;
    self.attriName.text = obj.name.."：";
    local arr = obj.arr;
    if arr ~= nil then -- 数组
        self.addBtn:setEnable(true);
        if self.protoItemArr == nil then
            self.protoItemArr = Array();
        end

        for i = 1, arr:getSize() do
            local item = Lua_MsgSimulateProtoGroupItem.new(self.content);
            item:setCallBack(self, self.onDelProto, self.onChangeProto, self.onItemValChange);
            item:setRectAnchor(1);
            item:setRectSize(700, 40);
            item:setData(arr[i], self.protoObj.typeStr);
            item:setLocation(self.offsetX, -20-self._ch);
            self._ch = self._ch + item:getHeight();
            self.protoItemArr:add(item);
            self.bg:SetDimensions(1440, self._ch - 2);
        end
    elseif self.protoObj.val ~= nil then
        self.addBtn:setEnable(false);
        if self.protoItemArr == nil then
            self.protoItemArr = Array();
        end
        for k, v in pairs(self.protoObj.val) do
            -- print("k", k, v, v.typeStr, v.name, v.tab, v.arr);
            if v.arr ~= nil then
                local item = Lua_MsgSimulateProtoAddItem.new(self.content);
                item:setCallBack(self, self.onChangeProto);
                item:setRectAnchor(1);
                item:setRectSize(700, 40);
                item:setData(v);
                item:setLocation(self.offsetX, -20-self._ch);
                self._ch = self._ch + item:getHeight();
                self.protoItemArr:add(item);
            else
                if v.typeStr == "number" or v.typeStr == "string" then
                    local item = Lua_MsgSimulateProtoValItem.new(self.content);
                    item:setRectAnchor(1);
                    item:setRectSize(700, 40);
                    item:setData(v);
                    item:setLocation(self.offsetX, -20-self._ch);
                    self._ch = self._ch + item:getHeight();
                    self.protoItemArr:add(item);
                else
                    local item = Lua_MsgSimulateProtoAddItem.new(self.content);
                    item:setCallBack(self, self.onChangeProto);
                    item:setRectAnchor(1);
                    item:setRectSize(700, 40);
                    item:setData(v);
                    item:setLocation(self.offsetX, -20-self._ch);
                    self._ch = self._ch + item:getHeight();
                    self.protoItemArr:add(item);
                end
            end
        end 
    end

    self.bg:SetDimensions(1440, self._ch - 2);
end














Lua_MsgSimulateProtoGroupItem = class("Lua_MsgSimulateProtoGroupItem", Lua_DragContainerItem);
function Lua_MsgSimulateProtoGroupItem:ctor(p)
    self:superCall("ctor", p, "MsgSimulateProtoGroupItem_skin", false);
end

function Lua_MsgSimulateProtoGroupItem:buildShowItem()
    self:superCall("buildShowItem");

    self._ch = 0;
    self.offsetX = 40;
    self.delBtn:addClickFuntion(self, self.onDelBtnClick);
    self.protoItemArr = Array();
end

function Lua_MsgSimulateProtoGroupItem:setCallBack(tb, fun, changFun, valChangeFun)
    self._cbTab = tb;
    self._cbFun = fun;
    self._cbChangFun = changFun;
    self._cbValChangeFun = valChangeFun;
end

function Lua_MsgSimulateProtoGroupItem:setOffsetX(val)
    self.offsetX = val;
end

function Lua_MsgSimulateProtoGroupItem:onDelBtnClick()
    if self._cbTab ~= nil and self._cbFun ~= nil then
        self._cbFun(self._cbTab, self);
    end
end

function Lua_MsgSimulateProtoGroupItem:clean()
    self._cbTab = nil;
    self._cbFun = nil;
    self._cbChangFun = nil;
    self._cbValChangeFun = nil;
    if self.protoItemArr ~= nil then
        local len = self.protoItemArr:getSize();
        while (len > 0) do
            local item = self.protoItemArr:remove(len);
            item:dispose();
            len = len - 1;
        end
    end

    self._ch = 0;
    self:superCall("clean");
end

function Lua_MsgSimulateProtoGroupItem:dispose()
    self._cbTab = nil;
    self._cbFun = nil;
    self._cbChangFun = nil;
    self._cbValChangeFun = nil;
    if self.protoItemArr ~= nil then
        local len = self.protoItemArr:getSize();
        while (len > 0) do
            local item = self.protoItemArr:remove(len);
            item:dispose();
            len = len - 1;
        end

        self.protoItemArr:dispose();
        self.protoItemArr = nil;
    end

    self:superCall("dispose");
end

function Lua_MsgSimulateProtoGroupItem:getWidth()
    return 700;
end

function Lua_MsgSimulateProtoGroupItem:getHeight()
    return self._ch;
end

function Lua_MsgSimulateProtoGroupItem:setData(obj, typeStr)
    if obj == nil then
        return;
    end

    self.typeStr = typeStr;
    if typeStr ~= nil then -- 数值
        local item = Lua_MsgSimulateProtoValItem.new(self.content);
        item:setRectAnchor(1);
        item:setRectSize(700, 40);
        item:setShowVal(typeStr, obj);
        item:setValChangeCallBack(self, self.onValChangeCallBack);
        item:setLocation(0, -20-self._ch);
        self._ch = self._ch + item:getHeight();
        self.protoItemArr:add(item);
        if self._ch > 0 then
            self.bg:SetDimensions(1440, self._ch - 2);
        else
            self.bg:SetDimensions(1440, 38);
        end
    else
        for k, v in pairs(obj) do
            if v.arr == nil then
                local item = Lua_MsgSimulateProtoValItem.new(self.content);
                item:setRectAnchor(1);
                item:setRectSize(700, 40);
                item:setData(v);
                item:setLocation(0, -20-self._ch);
                self._ch = self._ch + item:getHeight();
                self.protoItemArr:add(item);
            else
                local item = Lua_MsgSimulateProtoAddItem.new(self.content);
                item:setCallBack(self, self.onChangeItem);
                item:setRectAnchor(1);
                item:setRectSize(700, 40);
                item:setData(v);
                item:setLocation(0, -20-self._ch);
                self._ch = self._ch + item:getHeight();
                self.protoItemArr:add(item);
            end
        end
    end
end

function Lua_MsgSimulateProtoGroupItem:onChangeItem(item)
    if self.protoItemArr == nil then
        return;
    end

    self._ch = 0;
    local bChange = false;
    for i = 1, self.protoItemArr:getSize() do
        local it = self.protoItemArr[i];
        it:setLocation(self.offsetX, -20-self._ch);
        self._ch = self._ch + it:getHeight();
        if item == it then
            bChange = true;
        end
    end

    if bChange then
        self.bg:SetDimensions(1440, self._ch - 2);
        if self._cbTab ~= nil and self._cbChangFun ~= nil then
            self._cbChangFun(self._cbTab, self);
        end
    end
end

function Lua_MsgSimulateProtoGroupItem:onValChangeCallBack(val)
    if self._cbTab ~= nil and self._cbValChangeFun ~= nil then
        self._cbValChangeFun(self._cbTab, self, val);
    end
end